Attribute VB_Name = "oasis4i"
Option Explicit

'///////////////// OI DLL CONSTANTS /////////////////

'///////////////////////////////////////////
'// Return Codes
'///////////////////////////////////////////
Global Const OI_OK = 0
Global Const OI_FAILED = 1
Global Const OI_ABORT = 2
Global Const OI_NOHARDWARE = 4
Global Const OI_TIMEOUT = 8
Global Const OI_INVALIDARG = 16
Global Const OI_HARDWAREBUSY = 32
Global Const OI_ACCESSDENIED = 64
Global Const OI_NOTSUPPORTED = 128
Global Const OI_ILLEGALAXIS = 256
Global Const OI_INVALIDCONFIG = 512
Global Const OI_MAXMOVEFAIL = 1024

'///////////////////////////////////////////
'// Axes IDs
'///////////////////////////////////////////
Global Const OI_XAXIS = 1
Global Const OI_YAXIS = 2
Global Const OI_ZAXIS = 3
Global Const OI_FAXIS = 4
Global Const OI_TAXIS = 5
Global Const OI_SAXIS = 6

'///////////////////////////////////////////
'// DEVICE IDs
'///////////////////////////////////////////
Global Const OASIS_4I = 0
Global Const OASIS_BLUE = 1
Global Const OASIS_EXPRESS = 2

'///////////////////////////////////////////
'// MULTI-BOARD INFO
'///////////////////////////////////////////
Global Const OI_MAX_AXES = 20
Global Const MAX_BOARDS = 4
Global Const MAX_AXES_PER = 6

'///////////////////////////////////////////
'// AXIS ID HANDLING
'///////////////////////////////////////////
Global Const OI_MULTI_MODE_ID = 0        '// use 1 to MAX_AXES_PER*N, N=number of boards
Global Const OI_MULTI_MODE_ROUTE = 1     '// use 1 to MAX_AXES_PER on each board

'///////////////////////////////////////////
'// Axis Types (reserved)
'///////////////////////////////////////////
Global Const OI_TYPE_NOT_FITTED = 0
Global Const OI_TYPE_STEPPER = 1
Global Const OI_TYPE_DC = 2
Global Const OI_TYPE_SIMULATED = 3

'///////////////////////////////////////////
'// Init Methods (reserved)
'///////////////////////////////////////////
Global Const OI_INITBY_SWITCH = 0
Global Const OI_INITBY_MANUAL = 1

'///////////////////////////////////////////
'// Hardware Modes
'///////////////////////////////////////////
Global Const OI_NOTFITTED = -1
Global Const OI_SIM = 0
Global Const OI_OASIS = 1
Global Const OI_REMOTE = 2
Global Const OI_ONYX = 3
Global Const OI_LEICA_DM = 10
Global Const OI_LEICA_DM2 = 11
Global Const OI_LEICA_MZ = 12
Global Const OI_LEICA_AHM = 13
Global Const OI_LEICA_ISOPRO = 14
Global Const OI_LEICA_ZOOM = 15
Global Const OI_OLYMPUS_BX = 20
Global Const OI_OLYMPUS_IX = 21
Global Const OI_OLYMPUS_LASER_AF = 22
Global Const OI_NAVITAR = 50
Global Const OI_OPTEM = 51
Global Const OI_NANOZ = 60           '// Mad City Labs Nano-Z drives
Global Const OI_OASIS_DAC = 100
Global Const OI_BLUE_DAC1 = 101
Global Const OI_BLUE_DAC2 = 102
Global Const OI_BLUE_DAC3 = 103
Global Const OI_BLUE_DAC4 = 104
Global Const OI_PRIOR_LUMEN = 81
Global Const OI_CRI_MICROCOLOR = 90

'///////////////////////////////////////////
'// Status Codes
'///////////////////////////////////////////
Global Const S_LIMIT_PHY_NEG = &H1
Global Const S_LIMIT_USR_NEG = &H2
Global Const S_LIMIT_PHY_POS = &H8
Global Const S_LIMIT_USR_POS = &H4
Global Const S_LIMIT_USR_NEG_SET = &H10
Global Const S_LIMIT_USR_POS_SET = &H20
Global Const S_INITIALIZED = &H40
Global Const S_DIRECTION = &H80
Global Const S_MOVING = &H100
Global Const S_ENCODER_DIRECTION = &H200
Global Const S_ENCODER_MOVING = &H400
Global Const S_MOTOR_DETECTED = &H8000

'///////////////////////////////////////////
'// PCB STATUS BITS
'/*
'Bit meaning
'----------------
'31  Reserved
'30  Reserved
'29  Reserved
'28  Reserved
'27  Reserved
'26  Reserved
'25  Reserved
'24  Reserved
'23  Reserved
'22  Reserved
'21  Reserved
'20  Reserved
'19  Flash_user_OK       ( 1 = Flash user area checksum OK )
'18  Flash_OI_OK         ( 1 = Flash OI area checksum OK )
'17  Reserved
'16  Joystick_detect     ( 1 = Joystick unit fitted )
'15  Reserved
'14  Trackball_detect        ( 1 = Serial device is Kensington Trackball 5)
'13  Mouse_detect            ( 1 = Serial device is standard 2-button mouse)
'12  Serial_Device_detect        ( 1 = Serial device detected on RS232_0)
'11  Camera_type         ( 1 = Colour, 0 = Mono )
'10  Camera_frequency        ( 1 = 50 Hz, 0 = 60 Hz )
'9   Camera_channel      ( 1 = Channel 3, 0 = channel 0 (default))
'8   Camera_detect       ( 1 = Camera input detected )
'7   Video_Encoder_OK        ( 1 = Encoder configured OK )
'6   Autofocus_Module_type_1 ( 2 bit code indicating module type )
'5   Autofocus_Module_type_0 ( 2 bit code indicating module type )
'4   Autofocus_Module_fitted ( 1 = Module Detected )
'3   ADC_Analogue_input_X    ( 1 = ADC zero (correct) at switch on )
'2   ADC_Analogue_input_Y    ( 1 = ADC zero (correct) at switch on )
'1   PCB_Temperature     ( 1 = Temperature too high )
'0   Motor_volts_OK      ( 1 = Motor supply >= 10V i.e. OK )
'*/
'///////////////////////////////////////////
Global Const S_PCB_MOTOR_VOLTS_OK = &H1
Global Const S_PCB_TEMP_OK = &H2
Global Const S_PCB_ADC_YIN_OK = &H4
Global Const S_PCB_ADC_XIN_OK = &H8
Global Const S_PCB_AF_FITTED = &H10
Global Const S_PCB_AF_TYPE0 = &H20
Global Const S_PCB_AF_TYPE1 = &H40
Global Const S_PCB_VIDEO_ENCODER_OK = &H80
Global Const S_PCB_CAMERA_DETECTED = &H100
Global Const S_PCB_CAMERA_CHANNEL = &H200
Global Const S_PCB_CAMERA_FREQ = &H400
Global Const S_PCB_CAMERA_TYPE = &H800
Global Const S_PCB_SERIAL_DEV_DETECTED = &H1000
Global Const S_PCB_MOUSE_DETECTED = &H2000
Global Const S_PCB_TRACKBALL_FITTED = &H4000
'//      reserved                    &H8000
Global Const S_PCB_JOYSTICK_FITTED = &H10000
'//      reserved                    &H20000
Global Const S_PCB_FLASH_OI_OK = &H40000
Global Const S_PCB_FLASH_USER_OK = &H80000

Global Const S_PCBEX_XA1_FITTED = &H4
Global Const S_PCBEX_DC1_FITTED = &H1
Global Const S_PCBEX_EXPIO_FITTED = &H1
Global Const S_PCBEX_DAC_FITTED = &H3

'///////////////////////////////////////////
'// OASIS-4i Modules
'///////////////////////////////////////////
Global Const OASIS_AF = 1
Global Const OASIS_XA1 = 2
Global Const OASIS_DC1 = 3

'///////////////////////////////////////////
'// OASIS-blue Modules
'///////////////////////////////////////////
Global Const BLUE_EXPIO = 4
Global Const BLUE_DAC = 5


'////////////////////////////////////////////////////////
'// Predictive focus
'////////////////////////////////////////////////////////
Global Const OI_PF_MULTI_PLANE = 0
Global Const OI_PF_SINGLE_PLANE = 1
Global Const OI_PF_LOCAL_MEAN = 2
Global Const OI_PF_TRIANGULATE = 3

'////////////////////////////////////////////////////////
'// Piezo Focus
'////////////////////////////////////////////////////////

'// for OI_SetDAC Load parameters
Global Const OI_PIEZO_DONT_SET = 0
Global Const OI_PIEZO_SET_ON_FRAME_IRQ = 1
Global Const OI_PIEZO_SET_NOW = 2

'// for focus read, is the value the currently active device
'// or is it cumulative, e.g., Z = Zmotor + Zpiezo
'// See OI_SelectActiveFocusDevice and OI_SetFocusReadMode
Global Const OI_REPORT_Z_ACTIVE = 0
Global Const OI_REPORT_Z_CUMUL = 1

'///////////////////////////////////////////
'// Range constants
'///////////////////////////////////////////
Global Const OI_CRUISE_MIN = 0
Global Const OI_CRUISE_MAX = 511
Global Const OI_RAMP_MIN = 0
Global Const OI_RAMP_MAX = 3
Global Const OI_DRIVE_SPEED_MIN = -4096
Global Const OI_DRIVE_SPEED_MAX = 4096


'////////////////////////////////////////////////////////
'// Filter initialization methods
'////////////////////////////////////////////////////////
Global Const OI_FILTER_INIT_HOME = 0
Global Const OI_FILTER_INIT_LIMITS = 1
Global Const OI_FILTER_INIT_USER = 2

'////////////////////////////////////////////////////////
'// OI-SC4 Shutter Controller masks
'////////////////////////////////////////////////////////
Global Const SHUTTER1 = 1
Global Const SHUTTER2 = 2
Global Const SHUTTER3 = 4
Global Const SHUTTER4 = 8
Global Const OI_SHUTTER_OPEN = 65535
Global Const OI_SHUTTER_CLOSE = 0

'///////////////////////////////////////////////////////////////////////
'// Hardware defs
Declare Function OI_Open Lib "oasis4i.dll" () As Long
Declare Function OI_Close Lib "oasis4i.dll" () As Long
Declare Function OI_GetDriverOpen Lib "oasis4i" (bOpen As Long) As Long

Declare Function OI_SetHardwareMode Lib "oasis4i" (ByVal nMode As Long) As Long
Declare Function OI_GetHardwareMode Lib "oasis4i" (pnMode As Long) As Long

Declare Function OI_SetAutoFocusHWMode Lib "oasis4i" (ByVal nMode As Long) As Long
Declare Function OI_GetAutoFocusHWMode Lib "oasis4i" (pnMode As Long) As Long

Declare Function OI_GetAFFitted Lib "oasis4i" (pbFitted As Long) As Long
Declare Function OI_SetAFFitted Lib "oasis4i" (ByVal bFitted As Long) As Long

Declare Function OI_ReadPCBStatus Lib "oasis4i" (lpdwHWState As Long) As Long
Declare Function OI_ReadPCBTemperature Lib "oasis4i" (dTempC As Double) As Long
Declare Function OI_ReadADCValues Lib "oasis4i" (pwValArray As Integer) As Long

Declare Function OI_CountCards Lib "oasis4i" (pnFound As Long) As Long
Declare Function OI_SelectCard Lib "oasis4i" (ByVal nCard As Long) As Long
Declare Function OI_GetSelectedCard Lib "oasis4i" (pnCard As Long) As Long
Declare Function OI_ReadCardStatus Lib "oasis4i" (ByVal nCard As Long, lpdwStatus As Long) As Long
Declare Function OI_SetMultiAxisMode Lib "oasis4i" (ByVal nMode As Long) As Long
Declare Function OI_GetMultiAxisMode Lib "oasis4i" (pnMode As Long) As Long

'///////////////////////////////////////////////////////////////////////
'// Version functions
Declare Function OI_GetDriverVersion Lib "oasis4i" (ByVal pVersion As String, ByVal nStringLen As Long) As Long
Declare Function OI_ReadPCBID Lib "oasis4i" (ByVal pIDBuffer As String, ByVal nStringLen As Long) As Long
Declare Function OI_ReadPCBVersion Lib "oasis4i" (ByVal pVersion As String, ByVal nStringLen As Long) As Long

'///////////////////////////////////////////////////////////////////////
'// General, Single Axis
Declare Function OI_GetTotalAxisCount Lib "oasis4i" (pnAxisCount As Long) As Long
Declare Function OI_GetAxisEnabled Lib "oasis4i" (ByVal AxisID As Long, pbEnabled As Integer) As Long
Declare Function OI_MoveAxis Lib "oasis4i" (ByVal AxisID As Long, ByVal dValue As Double, ByVal nWait As Long) As Long
Declare Function OI_ReadAxis Lib "oasis4i" (ByVal AxisID As Long, pdVdalue As Double) As Long
Declare Function OI_GetAxisRange Lib "oasis4i" (ByVal AxisID As Long, pdMin As Double, pdMax As Double) As Long
Declare Function OI_SetAxisStepSize Lib "oasis4i" (ByVal AxisID As Long, ByVal dStepSize As Double) As Long
Declare Function OI_GetAxisStepSize Lib "oasis4i" (ByVal AxisID As Long, pdStepSize As Double) As Long
Declare Function OI_SetAxisBacklash Lib "oasis4i" (ByVal AxisID As Long, ByVal bEnabled As Integer) As Long
Declare Function OI_GetAxisBacklash Lib "oasis4i" (ByVal AxisID As Long, pbEnabled As Integer) As Long
Declare Function OI_GetAxisCruise Lib "oasis4i" (ByVal AxisID As Long, pnCruise As Long) As Long
Declare Function OI_SetAxisCruise Lib "oasis4i" (ByVal AxisID As Long, ByVal nCruise As Long) As Long
Declare Function OI_GetAxisSense Lib "oasis4i" (ByVal AxisID As Long, pnSense As Long) As Long
Declare Function OI_SetAxisSense Lib "oasis4i" (ByVal AxisID As Long, ByVal nSense As Long) As Long
Declare Function OI_GetAxisRamp Lib "oasis4i" (ByVal AxisID As Long, pnRamp As Long) As Long
Declare Function OI_SetAxisRamp Lib "oasis4i" (ByVal AxisID As Long, ByVal nRamp As Long) As Long
Declare Function OI_DriveAxisContinuous Lib "oasis4i" (ByVal AxisID As Long, ByVal nSpeed As Long) As Long
Declare Function OI_StepAxis Lib "oasis4i" (ByVal AxisID As Long, ByVal dValue As Double, ByVal nWait As Long) As Long
Declare Function OI_SetAxisInitMethod Lib "oasis4i" (ByVal AxisID As Long, ByVal nMethod As Long) As Long
Declare Function OI_GetAxisInitMethod Lib "oasis4i" (ByVal AxisID As Long, pnMethod As Long) As Long
Declare Function OI_ReadAxisAtLimit Lib "oasis4i" (ByVal AxisID As Long, pbAtNegLimit As Integer, pbAtPosLimit As Integer) As Long
Declare Function OI_ReadAxisMoving Lib "oasis4i" (ByVal AxisID As Long, pbIsMoving As Integer) As Long
Declare Function OI_ReadAxisStatus Lib "oasis4i" (ByVal AxisID As Long, lpwStatus As Integer) As Long
Declare Function OI_SetAxisToDefaults Lib "oasis4i" (ByVal AxisID As Long) As Long
Declare Function OI_ReadAxisRampValue Lib "oasis4i" (ByVal AxisID As Long, ByVal wIndex As Integer, lpwInterval As Integer, lpwStepSize As Integer) As Long
Declare Function OI_HaltAxis Lib "oasis4i" (ByVal AxisID As Long) As Long
Declare Function OI_GetAxisMaxMove Lib "oasis4i" (ByVal AxisID As Long, lpdwValue As Long) As Long
Declare Function OI_GetAxisStepsPerRev Lib "oasis4i" (ByVal AxisID As Long, lpdwStepsPerRev As Long) As Long
Declare Function OI_MoveAxisAbs Lib "oasis4i" (ByVal AxisID As Long, ByVal lPos As Long, ByVal nWait As Long) As Long
Declare Function OI_StepAxisAbs Lib "oasis4i" (ByVal AxisID As Long, ByVal lSteps As Long, ByVal nWait As Long) As Long
Declare Function OI_ReadAxisAbs Lib "oasis4i" (ByVal AxisID As Long, plPos As Long) As Long
Declare Function OI_GetAxisRangeAbs Lib "oasis4i" (ByVal AxisID As Long, plMin As Long, plMax As Long) As Long
Declare Function OI_WaitForAxisStopped Lib "oasis4i" (ByVal AxisID As Long) As Long

Declare Function OI_InitAxisByLimits Lib "oasis4i" (ByVal AxisID As Long, pdMin As Double, pdMax As Double) As Long
Declare Function OI_SetAxisPitch Lib "oasis4i" (ByVal AxisID As Long, ByVal dPitchMM As Double) As Long
Declare Function OI_GetAxisPitch Lib "oasis4i" (ByVal AxisID As Long, ByRef dPitchMM As Double) As Long
Declare Function OI_SetAxisTravel Lib "oasis4i" (ByVal AxisID As Long, ByVal dMin As Double, ByVal dMax As Double) As Long

Declare Function OI_InitAxisToHome Lib "oasis4i" (ByVal AxisID As Long) As Long
Declare Function OI_GetAxisHomeInfo Lib "oasis4i" (ByVal AxisID As Long, pUnitsPerRev As Double) As Long
Declare Function OI_ClearAxisHome Lib "oasis4i" (ByVal AxisID As Long) As Long
Declare Function OI_ReadAxisHome Lib "oasis4i" (ByVal AxisID As Long, lpbHomeFound As Long, pdHomeLeft As Double, pdHomeRight As Double) As Long

'///////////////////////////////////////////////////////////////////////
'// Encoder support
Declare Function OI_GetAxisEncoderFitted Lib "oasis4i" (ByVal AxisID As Long, lpbFitted As Long) As Long
Declare Function OI_GetAxisEncoderEnabled Lib "oasis4i" (ByVal AxisID As Long, lpbEnabled As Long, lpbAutoCorrect As Long) As Long
Declare Function OI_SetAxisEncoderEnabled Lib "oasis4i" (ByVal AxisID As Long, ByVal bEnabled As Long, ByVal bAutoCorrect As Long) As Long
Declare Function OI_GetAxisEncoderStepSize Lib "oasis4i" (ByVal AxisID As Long, pdMicrons As Double) As Long

Declare Function OI_SetEncoderEnabledXY Lib "oasis4i" (ByVal bEnabledX As Long, ByVal nTolX As Long, ByVal bEnabledY As Long, ByVal nTolY As Long) As Long
Declare Function OI_GetEncoderEnabledXY Lib "oasis4i" (pbEnabledX As Long, pnTolX As Long, pbEnabledY As Long, pnTolY As Long) As Long
Declare Function OI_SetEncoderEnabledZ Lib "oasis4i" (ByVal bEnabled As Long, ByVal nTol As Long) As Long
Declare Function OI_GetEncoderEnabledZ Lib "oasis4i" (pbEnabled As Long, pnTol As Long) As Long

Declare Function OI_SetEncoderModule Lib "oasis4i" (ByVal wOutputPulseWidth_usec As Integer, _
                            ByVal wComparitor1On As Integer, ByVal dwComparitor1Value As Long, _
                            ByVal wComparitor2On As Integer, ByVal dwComparitor2Value As Long, _
                            ByVal wReserved As Integer, ByVal dwReserved As Long, _
                            ByVal wReserved2 As Integer, ByVal dwReserved2 As Long, _
                            ByVal wOptions As Integer) As Long
        
Declare Function OI_ReadEncoderModule Lib "oasis4i" (pwInfo As Integer, pwOptions As Integer, pwOutputPulseWidth_usec As Integer, _
                            pdwComparitor1 As Long, _
                            pdwComparitor2 As Long, _
                            pdwReserved As Long, _
                            pdwReserved2 As Long) As Long

Declare Function OI_ReadEncoderValues Lib "oasis4i" (pdX As Double, pdY As Double, pdZ As Double, pdF As Double) As Long

Declare Function OI_SetEncoderClosedLoopResponseXYZ Lib "oasis4i" (ByVal nResponseX As Long, ByVal nResponseY As Long, ByVal nResponseZ As Long) As Long
Declare Function OI_GetEncoderClosedLoopResponseXYZ Lib "oasis4i" (pnResponseX As Long, pnResponseY As Long, pnResponseZ As Long) As Long

'///////////////////////////////////////////////////////////////////////
'// Full axes
Declare Function OI_SetPositionXYZ Lib "oasis4i" (ByVal xpos As Double, ByVal ypos As Double, ByVal zpos As Double) As Long
Declare Function OI_MoveToXYZ Lib "oasis4i" (ByVal xpos As Double, ByVal ypos As Double, ByVal zpos As Double, ByVal nWait As Long) As Long
Declare Function OI_MoveToXYZ_Auto Lib "oasis4i" (ByVal xpos As Double, ByVal ypos As Double, ByVal zpos As Double, ByVal nWait As Long) As Long
Declare Function OI_ReadXYZ Lib "oasis4i" (xpos As Double, ypos As Double, zpos As Double) As Long
Declare Function OI_WaitForStoppedXYZ Lib "oasis4i" (ByVal xstop As Long, ByVal ystop As Long, ByVal zstop As Long) As Long
Declare Function OI_DriveContinuousXYZ Lib "oasis4i" (ByVal nXSpeed As Long, ByVal nYSpeed As Long, ByVal nZSpeed As Long) As Long

'///////////////////////////////////////////////////////////////////////
'// XY Stage conveniences: X and Y Axes combined
Declare Function OI_InitializeXY Lib "oasis4i" () As Long
Declare Function OI_SetPositionXY Lib "oasis4i" (ByVal xpos As Double, ByVal ypos As Double) As Long
Declare Function OI_SetOriginXY Lib "oasis4i" () As Long
Declare Function OI_ReadXY Lib "oasis4i" (xpos As Double, ypos As Double) As Long
Declare Function OI_MoveToXY Lib "oasis4i" (ByVal xpos As Double, ByVal ypos As Double, ByVal nWait As Long) As Long
Declare Function OI_MoveToXY_Auto Lib "oasis4i" (ByVal xpos As Double, ByVal ypos As Double, ByVal nWait As Long) As Long
Declare Function OI_StepXY Lib "oasis4i" (ByVal dXDistance As Double, ByVal dYDistance As Double, ByVal nWait As Long) As Long
Declare Function OI_StepX Lib "oasis4i" (ByVal dXDistance As Double, ByVal nWait As Long) As Long
Declare Function OI_StepY Lib "oasis4i" (ByVal dYDistance As Double, ByVal nWait As Long) As Long
Declare Function OI_ReadStatusXY Lib "oasis4i" (lpwXStatus As Integer, lpwYStatus As Integer) As Long
Declare Function OI_GetPitchXY Lib "oasis4i" (pdXPitch As Double, pdYPitch As Double) As Long
Declare Function OI_SetPitchXY Lib "oasis4i" (ByVal dXPitch As Double, ByVal dYPitch As Double) As Long
Declare Function OI_SetRampXY Lib "oasis4i" (ByVal nXRamp As Long, ByVal nYRamp As Long) As Long
Declare Function OI_GetRampXY Lib "oasis4i" (pnXRamp As Long, pnYRamp As Long) As Long
Declare Function OI_SetCruiseXY Lib "oasis4i" (ByVal nXCruise As Long, ByVal nYCruise As Long) As Long
Declare Function OI_GetCruiseXY Lib "oasis4i" (pnXCruise As Long, pnYCruise As Long) As Long
Declare Function OI_SetDriveSenseXY Lib "oasis4i" (ByVal nXDir As Long, ByVal nYDir As Long) As Long
Declare Function OI_GetDriveSenseXY Lib "oasis4i" (pnXDir As Long, pnYDir As Long) As Long
Declare Function OI_DriveContinuousXY Lib "oasis4i" (ByVal nXSpeed As Long, ByVal nYSpeed As Long) As Long
Declare Function OI_HaltXY Lib "oasis4i" () As Long
Declare Function OI_SetUserLimitsXY Lib "oasis4i" (ByVal dXMin As Double, ByVal dXMax As Double, ByVal dYMin As Double, ByVal dYMax As Double) As Long
Declare Function OI_GetUserLimitsXY Lib "oasis4i" (pdXMin As Double, pdXMax As Double, pdYMin As Double, pdYMax As Double) As Long
Declare Function OI_ReadLimitAlarmsXY Lib "oasis4i" (XNeg As Long, xpos As Long, YNeg As Long, ypos As Long) As Long

'///////////////////////////////////////////////////////////////////////
'// Z Axis
Declare Function OI_InitializeZ Lib "oasis4i.dll" (ByVal ZRangeAbove As Double, ByVal ZRangeBelow As Double) As Long
Declare Function OI_SetPositionZ Lib "oasis4i.dll" (ByVal zpos As Double) As Long
Declare Function OI_ReadZ Lib "oasis4i.dll" (zpos As Double) As Long
Declare Function OI_MoveToZ Lib "oasis4i.dll" (ByVal zpos As Double, ByVal nWait As Long) As Long
Declare Function OI_StepZ Lib "oasis4i.dll" (ByVal ZDistance As Double, ByVal nWait As Long) As Long
Declare Function OI_ReadStatusZ Lib "oasis4i" (lpwStatus As Integer) As Long
Declare Function OI_SetRampZ Lib "oasis4i" (ByVal nZRamp As Long) As Long
Declare Function OI_GetRampZ Lib "oasis4i" (pnZRamp As Long) As Long
Declare Function OI_SetCruiseZ Lib "oasis4i" (ByVal nZCruise As Long) As Long
Declare Function OI_GetCruiseZ Lib "oasis4i" (pnZCruise As Long) As Long
Declare Function OI_SetDriveSenseZ Lib "oasis4i" (ByVal nZDir As Long) As Long
Declare Function OI_GetDriveSenseZ Lib "oasis4i" (pnZDir As Long) As Long
Declare Function OI_DriveContinuousZ Lib "oasis4i" (ByVal nSpeed As Long) As Long
Declare Function OI_HaltZ Lib "oasis4i" () As Long
Declare Function OI_ReadRangeZ Lib "oasis4i" (pZMin As Double, pZMax As Double) As Long
Declare Function OI_SetUserLimitsZ Lib "oasis4i" (ByVal dZMin As Double, ByVal dZMax As Double) As Long
Declare Function OI_GetUserLimitsZ Lib "oasis4i" (pdZMin As Double, pdZMax As Double) As Long
Declare Function OI_SetFocusJoystick Lib "oasis4i" (ByVal nLeft As Long, ByVal nRight As Long) As Long
Declare Function OI_SetOriginZ Lib "oasis4i" () As Long
Declare Function OI_GetPitchZ Lib "oasis4i" (ByRef pdZPitchMM As Double) As Long


'///////////////////////////////////////////////////////////////////////
'// Piezo Z via Dac1 on BLUE-DAC
Declare Function OI_IsPiezoFitted Lib "oasis4i" (pbFitted As Long) As Long
Declare Function OI_SetPiezoZ Lib "oasis4i" (ByVal Z As Double) As Long
Declare Function OI_ReadPiezoZ Lib "oasis4i" (pZ As Double) As Long
Declare Function OI_SetPiezoOrigin Lib "oasis4i" () As Long
Declare Function OI_SetPiezoRange Lib "oasis4i" (ByVal dRangeMicrons As Double) As Long
Declare Function OI_GetPiezoRange Lib "oasis4i" (pdRangeMicrons As Double) As Long
Declare Function OI_GetPiezoLimits Lib "oasis4i" (pdMin As Double, pdMax As Double) As Long
Declare Function OI_InitPiezo Lib "oasis4i" (ByVal bFindLImits As Long) As Long
Declare Function OI_SweepPiezo Lib "oasis4i" (ByVal wTriggerMode As Integer, ByVal wTriggerDelayMsec As Integer, _
                                                ByVal dStart As Double, ByVal dFinish As Double, ByVal wNumEvents As Integer) As Long

Declare Function OI_SelectActiveFocusDevice Lib "oasis4i" (ByVal nCoarseOrFine As Long) As Long
Declare Function OI_GetActiveFocusDevice Lib "oasis4i" (pnCoarseOrFine As Long) As Long

Declare Function OI_SetFocusReadMode Lib "oasis4i" (ByVal nFocusReadMode As Long) As Long
Declare Function OI_GetFocusReadMode Lib "oasis4i" (pnFocusReadMode As Long) As Long

Declare Function OI_SetPiezoADCSettings Lib "oasis4i" (ByVal wADCMin As Integer, ByVal wADCMax As Integer, ByVal wADCThresh As Integer) As Long
Declare Function OI_GetPiezoADCSettings Lib "oasis4i" (pwADCMin As Integer, pwADCMax As Integer, pwADCThresh As Integer) As Long
Declare Function OI_SetPiezoDacChannel Lib "oasis4i" (ByVal nChan As Long) As Long
Declare Function OI_GetPiezoDacChannel Lib "oasis4i" (pnChan As Long) As Long

'///////////////////////////////////////////////////////////////////////
'// F Axis
Declare Function OI_InitializeF Lib "oasis4i" () As Long
Declare Function OI_InitializeFRange Lib "oasis4i" (ByVal FNegLimit As Double, ByVal FPosLimit As Double) As Long
Declare Function OI_SetPositionF Lib "oasis4i" (ByVal dFPos As Double) As Long
Declare Function OI_ReadF Lib "oasis4i" (pF As Double) As Long
Declare Function OI_MoveToF Lib "oasis4i" (ByVal f As Double, ByVal nWait As Long) As Long
Declare Function OI_StepF Lib "oasis4i" (ByVal FDistance As Double, ByVal nWait As Long) As Long
Declare Function OI_ReadStatusF Lib "oasis4i" (lpwStatus As Integer) As Long
Declare Function OI_SetRampF Lib "oasis4i" (ByVal nFRamp As Long) As Long
Declare Function OI_GetRampF Lib "oasis4i" (pnFRamp As Long) As Long
Declare Function OI_SetCruiseF Lib "oasis4i" (ByVal nFCruise As Long) As Long
Declare Function OI_GetCruiseF Lib "oasis4i" (pnFCruise As Long) As Long
Declare Function OI_SetDriveSenseF Lib "oasis4i" (ByVal nFDir As Long) As Long
Declare Function OI_GetDriveSenseF Lib "oasis4i" (pnFDir As Long) As Long
Declare Function OI_HaltF Lib "oasis4i" () As Long
Declare Function OI_ReadRangeF Lib "oasis4i" (pFMin As Double, pFMax As Double) As Long
Declare Function OI_GetStepSizeF Lib "oasis4i" (dStepSize As Double) As Long
Declare Function OI_SetStepSizeF Lib "oasis4i" (ByVal dStepSize As Double) As Long
Declare Function OI_WaitForStoppedF Lib "oasis4i" () As Long
Declare Function OI_SetUserLimitsF Lib "oasis4i" (ByVal pFMin As Double, ByVal pFMax As Double) As Long
Declare Function OI_GetUserLimitsF Lib "oasis4i" (pFMin As Double, pFMax As Double) As Long
Declare Function OI_SetOriginF Lib "oasis4i" () As Long

'///////////////////////////////////////////////////////////////////////
'// T Axis
Declare Function OI_InitializeT Lib "oasis4i" () As Long
Declare Function OI_InitializeTRange Lib "oasis4i" (ByVal dNegLimit As Double, ByVal dPosLimit As Double) As Long
Declare Function OI_SetPositionT Lib "oasis4i" (ByVal dPos As Double) As Long
Declare Function OI_ReadT Lib "oasis4i" (pdPos As Double) As Long
Declare Function OI_MoveToT Lib "oasis4i" (ByVal dPos As Double, ByVal nWait As Long) As Long
Declare Function OI_StepT Lib "oasis4i" (ByVal dDistance As Double, ByVal nWait As Long) As Long
Declare Function OI_ReadStatusT Lib "oasis4i" (lpwStatus As Integer) As Long
Declare Function OI_SetRampT Lib "oasis4i" (ByVal nRamp As Long) As Long
Declare Function OI_GetRampT Lib "oasis4i" (pnRamp As Long) As Long
Declare Function OI_SetCruiseT Lib "oasis4i" (ByVal nCruise As Long) As Long
Declare Function OI_GetCruiseT Lib "oasis4i" (pnCruise As Long) As Long
Declare Function OI_SetDriveSenseT Lib "oasis4i" (ByVal nDir As Long) As Long
Declare Function OI_GetDriveSenseT Lib "oasis4i" (pnDir As Long) As Long
Declare Function OI_HaltT Lib "oasis4i" () As Long
Declare Function OI_ReadRangeT Lib "oasis4i" (pdMin As Double, pdMax As Double) As Long
Declare Function OI_GetStepSizeT Lib "oasis4i" (dStepSize As Double) As Long
Declare Function OI_SetStepSizeT Lib "oasis4i" (ByVal dStepSize As Double) As Long
Declare Function OI_WaitForStoppedT Lib "oasis4i" () As Long
Declare Function OI_SetUserLimitsT Lib "oasis4i" (ByVal dMin As Double, ByVal dMax As Double) As Long
Declare Function OI_GetUserLimitsT Lib "oasis4i" (pdMin As Double, pdMax As Double) As Long
Declare Function OI_SetOriginT Lib "oasis4i" () As Long
Declare Function OI_ReadLimitAlarmsT Lib "oasis4i" (pnNeg As Long, pnPos As Long) As Long
Declare Function OI_SetPitchT Lib "oasis4i" (ByVal dPitchMM As Double) As Long
Declare Function OI_GetPitchT Lib "oasis4i" (pdPitchMM As Double) As Long
Declare Function OI_ReadMaxMoveT Lib "oasis4i" (lpdwSteps As Long, lpwDecel As Integer) As Long
Declare Function OI_GetSpeedT Lib "oasis4i" (pdSpeed As Double) As Long
Declare Function OI_SelectSpeedT Lib "oasis4i" (ByVal dFmmPerSec As Double, ByVal nFlags As Long) As Long
Declare Function OI_LookupSpeedT Lib "oasis4i" (ByVal nCruise As Long, pdSpeed As Double) As Long
Declare Function OI_ClearUserLimitsT Lib "oasis4i" () As Long

'///////////////////////////////////////////////////////////////////////
'// S Axis
Declare Function OI_InitializeS Lib "oasis4i" () As Long
'Declare Function OI_InitializeTRange Lib "oasis4i" (ByVal dNegLimit As Double, ByVal dPosLimit As Double) As Long
Declare Function OI_SetPositionS Lib "oasis4i" (ByVal dPos As Double) As Long
Declare Function OI_ReadS Lib "oasis4i" (pdPos As Double) As Long
Declare Function OI_MoveToS Lib "oasis4i" (ByVal dPos As Double, ByVal nWait As Long) As Long
Declare Function OI_StepS Lib "oasis4i" (ByVal dDistance As Double, ByVal nWait As Long) As Long
Declare Function OI_ReadStatusS Lib "oasis4i" (lpwStatus As Integer) As Long
Declare Function OI_SetRampS Lib "oasis4i" (ByVal nRamp As Long) As Long
Declare Function OI_GetRampS Lib "oasis4i" (pnRamp As Long) As Long
Declare Function OI_SetCruiseS Lib "oasis4i" (ByVal nCruise As Long) As Long
Declare Function OI_GetCruiseS Lib "oasis4i" (pnCruise As Long) As Long
Declare Function OI_SetDriveSenseS Lib "oasis4i" (ByVal nDir As Long) As Long
Declare Function OI_GetDriveSenseS Lib "oasis4i" (pnDir As Long) As Long
Declare Function OI_HaltS Lib "oasis4i" () As Long
Declare Function OI_ReadRangeS Lib "oasis4i" (pdMin As Double, pdMax As Double) As Long
Declare Function OI_GetStepSizeS Lib "oasis4i" (dStepSize As Double) As Long
Declare Function OI_SetStepSizeS Lib "oasis4i" (ByVal dStepSize As Double) As Long
Declare Function OI_WaitForStoppedS Lib "oasis4i" () As Long
Declare Function OI_SetUserLimitsS Lib "oasis4i" (ByVal dMin As Double, ByVal dMax As Double) As Long
Declare Function OI_GetUserLimitsS Lib "oasis4i" (pdMin As Double, pdMax As Double) As Long
Declare Function OI_SetOriginS Lib "oasis4i" () As Long
Declare Function OI_ReadLimitAlarmsS Lib "oasis4i" (pnNeg As Long, pnPos As Long) As Long
Declare Function OI_SetPitchS Lib "oasis4i" (ByVal dPitchMM As Double) As Long
Declare Function OI_GetPitchS Lib "oasis4i" (pdPitchMM As Double) As Long
Declare Function OI_ReadMaxMoveS Lib "oasis4i" (lpdwSteps As Long, lpwDecel As Integer) As Long
Declare Function OI_GetSpeedS Lib "oasis4i" (pdSpeed As Double) As Long
Declare Function OI_SelectSpeedS Lib "oasis4i" (ByVal dFmmPerSec As Double, ByVal nFlags As Long) As Long
Declare Function OI_LookupSpeedS Lib "oasis4i" (ByVal nCruise As Long, pdSpeed As Double) As Long
Declare Function OI_ClearUserLimitsS Lib "oasis4i" () As Long

'///////////////////////////////////////////////////////////////////////
'// Autofocus
Declare Function OI_SetAutoFocus Lib "oasis4i" (ByVal dRange As Double, ByVal Speed As Long, ByVal Tolerance As Long) As Long
Declare Function OI_GetAutoFocus Lib "oasis4i" (pdRange As Double, Speed As Long, pnTolerance As Long) As Long
Declare Function OI_AutoFocus Lib "oasis4i" () As Long
Declare Function OI_AutoFocusEx Lib "oasis4i" (ByVal dRange As Double, ByVal Speed As Long, ByVal Tolerance As Long) As Long
Declare Function OI_AutoFocus_Step Lib "oasis4i" (ByVal dRange As Double, ByVal Speed As Long, ByVal Tolerance As Long, ByVal dStepSize As Double) As Long
Declare Function OI_SetAutoFocusThreshold Lib "oasis4i" (ByVal wThresh As Integer) As Long
Declare Function OI_GetAutoFocusThreshold Lib "oasis4i" (lpwThresh As Integer) As Long
Declare Function OI_ReadFocusScore Lib "oasis4i" (Score As Double) As Long
Declare Function OI_ReadFocusScoreEx Lib "oasis4i" (Score As Double, zpos As Double) As Long
Declare Function OI_ReadFocusProfile Lib "oasis4i" (pdArray As Double, pdZPos As Double, ByVal nSize As Long, pnSamples As Long) As Long
Declare Function OI_RequestAutoFocusStatus Lib "oasis4i" (Finished As Integer, Success As Integer, NumSamples As Integer) As Long
Declare Function OI_RequestFocusStatus Lib "oasis4i" (status As Integer) As Long
Declare Function OI_WaitForAutoFocus Lib "oasis4i" () As Long

'////////////////////////////////////////////////////////
'// predictive focus
Declare Function OI_SetPredictiveZ Lib "oasis4i" (xvals As Double, yvals As Double, zvals As Double) As Long
Declare Function OI_GetPredictiveZ Lib "oasis4i" (ByVal x As Double, ByVal y As Double, zpred As Double, status As Long) As Long
Declare Function OI_GetPredictiveFlag Lib "oasis4i" (pbFlag As Long) As Long
Declare Function OI_SetPredictiveFlag Lib "oasis4i" (ByVal bFlag As Long) As Long
Declare Function OI_GetPredictiveZPoints Lib "oasis4i" (xvals As Double, yvals As Double, zvals As Double) As Long

Declare Function OI_SetAutoPredictiveZ Lib "oasis4i" (ByVal bEnabled As Long) As Long
Declare Function OI_GetAutoPredictiveZ Lib "oasis4i" (pbEnabled As Long, pbValid As Long, pdZPred As Double) As Long
Declare Function OI_SetAutoPredictiveZParams Lib "oasis4i" (ByVal dX1 As Double, ByVal dY1 As Double, ByVal dZ1 As Double, ByVal dCoeffA As Double, ByVal dCoeffB As Double, ByVal dCoeffC As Double) As Long

Declare Function OI_GetAutoPredictiveZParams Lib "oasis4i" (pbEnabled As Long, pbValid As Long, pdX1 As Double, pdY1 As Double, pdZ1 As Double, pdCoeffA As Double, pdCoeffB As Double, pdCoeffC As Double) As Long
Declare Function OI_InvalidatePredictiveZ Lib "oasis4i" () As Long
Declare Function OI_SetPredictiveZOffset Lib "oasis4i" (ByVal dOffset As Double) As Long
Declare Function OI_GetPredictiveZOffset Lib "oasis4i" (pdOffset As Double) As Long

Declare Function OI_SetMultiPredictiveZ Lib "oasis4i" (ByVal nMethod As Long, ByVal nPoints As Long, xvals As Double, yvals As Double, zvals As Double) As Long
Declare Function OI_GetMultiPredictiveZ Lib "oasis4i" (pnMethod As Long, pnPoints As Long, xvals As Double, yvals As Double, zvals As Double) As Long
Declare Function OI_UpdatePredictiveZ Lib "oasis4i" (ByVal nOption As Long) As Long

Declare Function OI_GetPredictiveZDomains Lib "oasis4i" (pnDomains As Long, ax As Double, ay As Double, az As Double, bx As Double, by As Double, bz As Double, cx As Double, cy As Double, cz As Double) As Long
Declare Function OI_GetCoincDomain Lib "oasis4i" (ByVal xpos As Double, ByVal ypos As Double, pnDomainIndex As Long) As Long

'///////////////////////////////////////////////////////////////////////
'// Video
Declare Function OI_SetVideoSettings Lib "oasis4i" (ByVal nEvenPhase As Long, ByVal nEvenThreshold As Long, ByVal nOddPhase As Long, ByVal nOddThreshold As Long) As Long
Declare Function OI_GetVideoSettings Lib "oasis4i" (nEvenPhase As Long, nEvenThreshold As Long, nOddPhase As Long, nOddThreshold As Long) As Long
Declare Function OI_ReadVideoData Lib "oasis4i" (nStatus As Integer, pdwArea As Long, pwMaxChord As Integer, pwMaxGradient As Integer) As Long
Declare Function OI_ReadVideoResults Lib "oasis4i" (ByVal nMode As Long, pdwArea As Long, pwMaxChord As Integer) As Long
Declare Function OI_ReadVideoResultsEx Lib "oasis4i" (ByVal nMode, pdwArea As Long, pwMaxChord As Integer, pwMaxGradient As Integer) As Long
Declare Function OI_ReadVideoResultsXYZF Lib "oasis4i" (ByVal nMode As Long, pdResults As Double, pdPositions As Double) As Long
Declare Function OI_ReadVideoResultsZ Lib "oasis4i" (ByVal nMode As Long, pdResults As Double, pdZPos As Double) As Long
Declare Function OI_ReadVideoResultsXY Lib "oasis4i" (ByVal nMode As Long, pdResults As Double, pdXPos As Double, pdYPos As Double) As Long
Declare Function OI_IsVideoDetected Lib "oasis4i" (bFound As Long) As Long
Declare Function OI_SetVideoWindow Lib "oasis4i" (ByVal nXStart As Long, ByVal nXStop As Long, ByVal nYStart As Long, ByVal nYStop As Long) As Long
Declare Function OI_GetVideoWindow Lib "oasis4i" (nXStart As Long, nXStop As Long, nYStart As Long, nYStop As Long) As Long

'///////////////////////////////////////////////////////////////////////
'// General stops
Declare Function OI_HaltAllAxes Lib "oasis4i" () As Long
Declare Function OI_EmergencyStopAll Lib "oasis4i" () As Long

'///////////////////////////////////////////////////////////////////////
'// Timeouts
Declare Function OI_SetVideoTimeout Lib "oasis4i" (ByVal dwMSecs As Long) As Long
Declare Function OI_GetVideoTimeout Lib "oasis4i" (lpdwMSecs As Long) As Long
Declare Function OI_SetAutoFocusTimeout Lib "oasis4i" (ByVal dwMSecs As Long) As Long
Declare Function OI_GetAutoFocusTimeout Lib "oasis4i" (lpdwMSecs As Long) As Long
Declare Function OI_SetMoveTimeout Lib "oasis4i" (ByVal dwMSecs As Long) As Long
Declare Function OI_GetMoveTimeout Lib "oasis4i" (lpdwMSecs As Long) As Long
Declare Function OI_SetFilterTimeout Lib "oasis4i" (ByVal dwMSecs As Long) As Long
Declare Function OI_GetFilterTimeout Lib "oasis4i" (lpdwMSecs As Long) As Long

'///////////////////////////////////////////////////////////////////////
'// Joystick
Declare Function OI_SetJoystickEnabled Lib "oasis4i" (ByVal bXEnabled As Long, ByVal bYEnabled As Long, ByVal bZEnabled As Long) As Long
Declare Function OI_GetJoystickEnabled Lib "oasis4i" (bXEnabled As Long, bYEnabled As Long, bZEnabled As Long) As Long
Declare Function OI_SetJoystickSense Lib "oasis4i" (ByVal nXSense As Long, ByVal nYSense As Long, ByVal nZSense As Long) As Long
Declare Function OI_GetJoystickSense Lib "oasis4i" (pnXSense As Long, pnYSense As Long, pnZSense As Long) As Long

Declare Function OI_ReadTrackballStatus Lib "oasis4i" (pwStatus As Integer) As Long
Declare Function OI_ClearTrackballStatus Lib "oasis4i" (ByVal wMask As Integer) As Long
Declare Function OI_SetTrackballControl Lib "oasis4i" (ByVal wEnable As Integer) As Long
Declare Function OI_GetTrackballControl Lib "oasis4i" (pwEnable As Integer) As Long
Declare Function OI_SetTrackballEnabled Lib "oasis4i" (ByVal bEnable As Long) As Long
Declare Function OI_GetTrackballEnabled Lib "oasis4i" (pbEnable As Long) As Long

Declare Function OI_SetJoystickSettings Lib "oasis4i" (ByVal wZDeviceSelect As Integer, pwJoySensitivities As Integer, wDigiSensitivities As Integer, ByVal wMicPassThrough As Integer, pwJoyButtons As Integer, pwSmartMoveButtons As Integer) As Long
Declare Function OI_GetJoystickSettings Lib "oasis4i" (pwZDeviceSelect As Integer, pwJoySensitivities As Integer, wDigiSensitivities As Integer, pwMicPassThrough As Integer, pwJoyButtons As Integer, pwSmartMoveButtons As Integer) As Long


'///////////////////////////////////////////////////////////////////////
'// Low-level counters
Declare Function OI_ReadCounters Lib "oasis4i" (lpdwX As Integer, lpdwY As Integer, lpdwZ As Integer, lpdwF As Integer) As Long
Declare Function OI_ReadCountersEx Lib "oasis4i" (lpdwDSP As Integer, lpdwEncoders As Integer) As Long
Declare Function OI_SetCountersEx Lib "oasis4i" (lpdwDSP As Integer, lpdwEncoders As Integer) As Long


'///////////////////////////////////////////////////////////////////////
'// File I/O
Declare Function OI_SaveSettings Lib "oasis4i" (ByVal sFile As String) As Long
Declare Function OI_LoadSettings Lib "oasis4i" (ByVal sFile As String) As Long
Declare Function OI_SavePositions Lib "oasis4i" (ByVal sFile As String) As Long
Declare Function OI_LoadPositions Lib "oasis4i" (ByVal sFile As String) As Long

'///////////////////////////////////////////////////////////////////////
'// Filter Changer
Declare Function OI_SetFilterCount Lib "oasis4i" (ByVal nFilters As Long) As Long
Declare Function OI_GetFilterCount Lib "oasis4i" (pnFilters As Long) As Long
Declare Function OI_DeleteFilter Lib "oasis4i" (ByVal nPosition As Long) As Long
Declare Function OI_MoveToFilter Lib "oasis4i" (ByVal nPosition As Long, ByVal nWait As Long) As Long
Declare Function OI_GetFilterPosition Lib "oasis4i" (pnPosition As Long) As Long
Declare Function OI_InitFilterChanger Lib "oasis4i" (ByVal nMethod As Long, ByVal dUnitsPerRev As Double) As Long
Declare Function OI_SetFilterHomeOffset Lib "oasis4i" (ByVal dOffset As Double) As Long
Declare Function OI_GetFilterHomeOffset Lib "oasis4i" (pdOffset As Double) As Long
Declare Function OI_WaitForStoppedFilter Lib "oasis4i" () As Long
Declare Function OI_SetFilterName Lib "oasis4i" (ByVal nPosition As Long, ByVal szBuffer As String) As Long
Declare Function OI_GetFilterName Lib "oasis4i" (ByVal nPosition As Long, ByVal szBuffer As String, ByVal nBufferLen As Long) As Long
Declare Function OI_SetFilterDescription Lib "oasis4i" (ByVal nPosition As Long, ByVal szBuffer As String) As Long
Declare Function OI_GetFilterDescription Lib "oasis4i" (ByVal nPosition As Long, ByVal szBuffer As String, ByVal nBufferLen As Long) As Long
Declare Function OI_ReadFilterHomeInfo Lib "oasis4i" (lpbHomeFound As Integer, pdHomeLeft As Double, pdHomeRight As Double) As Long
Declare Function OI_ReadFilterChangerInfo Lib "oasis4i" (pdUnitsPerRev As Double, pdFilterSpacing As Double) As Long
Declare Function OI_SetFilterOffset Lib "oasis4i" (ByVal nPosition As Long, ByVal dOffset As Double) As Long
Declare Function OI_GetFilterOffset Lib "oasis4i" (ByVal nPosition As Long, pdOffset As Double) As Long
Declare Function OI_SetFilterLocation Lib "oasis4i" (ByVal nPosition As Long) As Long
Declare Function OI_ClearFilterHomeInfo Lib "oasis4i" (void) As Long

Declare Function OI_SelectFilterChanger Lib "oasis4i" (ByVal nChanger As Long) As Long
Declare Function OI_GetFilterChanger Lib "oasis4i" (pnChanger As Long) As Long
Declare Function OI_GetFilterChangerCount Lib "oasis4i" (pnChangers As Long) As Long
Declare Function OI_GetFilterChangerInfo Lib "oasis4i" (ByVal nChanger As Long, pnCard As Long, pnAxisID As Long) As Long
Declare Function OI_SetFilterChangerInfo Lib "oasis4i" (ByVal nChanger As Long, ByVal nCard As Long, ByVal nAxisID As Long) As Long
Declare Function OI_IsFilterChangerDetected Lib "oasis4i" (ByVal nChanger As Long, pbDetected As Integer) As Long
Declare Function OI_SetFilterChangerConfig Lib "oasis4i" (ByVal nChanger As Long, ByVal nControl As Long) As Long
Declare Function OI_GetFilterChangerConfig Lib "oasis4i" (ByVal nChanger As Long, pnControl As Long) As Long

Declare Function OI_SetFilterChangerCruise Lib "oasis4i" (ByVal nChanger As Long, ByVal nCruise As Long) As Long
Declare Function OI_GetFilterChangerCruise Lib "oasis4i" (ByVal nChanger As Long, pnCruise As Long) As Long
Declare Function OI_SetFilterChangerRamp Lib "oasis4i" (ByVal nChanger As Long, ByVal nRamp As Long) As Long
Declare Function OI_GetFilterChangerRamp Lib "oasis4i" (ByVal nChanger As Long, pnRamp As Long) As Long

Declare Function OI_SetShutter Lib "oasis4i" (ByVal nPosition As Long, ByVal nShutter As Long) As Long
Declare Function OI_GetShutter Lib "oasis4i" (pnPosition As Long, ByVal nShutter As Long) As Long
Declare Function OI_SetShutterMulti Lib "oasis4i" (ByVal nStates As Long, ByVal nStateMask As Long) As Long
Declare Function OI_GetShutterMulti Lib "oasis4i" (pnStates As Long) As Long

'///////////////////////////////////////////////////////////////////////
'// Changer
Declare Function OI_GetContrastModeCount Lib "oasis4i" (pnModes As Long) As Long
Declare Function OI_GetContrastMode Lib "oasis4i" (pnMode As Long) As Long
Declare Function OI_SetContrastMode Lib "oasis4i" (ByVal nMode As Long, ByVal nWait As Long) As Long
Declare Function OI_GetContrastModeName Lib "oasis4i" (ByVal nMode As Long, ByVal szName As String, ByVal nLen As Long) As Long

Declare Function OI_ChangerGetCount Lib "oasis4i" (pnChangers As Long) As Long
Declare Function OI_ChangerSetController Lib "oasis4i" (ByVal nChanger As Long, ByVal nController As Long) As Long
Declare Function OI_ChangerConfigure Lib "oasis4i" (ByVal nChanger As Long, ByVal nController As Long, ByVal nComponent As Long, ByVal nOption As Long) As Long
Declare Function OI_ChangerGetConfiguration Lib "oasis4i" (ByVal nChanger As Long, pnController As Long, pnComponent As Long, pnOption As Long) As Long
Declare Function OI_ChangerGetName Lib "oasis4i" (ByVal nChanger As Long, ByVal szBuff As String, ByVal nBuffLen As Long) As Long
Declare Function OI_ChangerSetName Lib "oasis4i" (ByVal nChanger As Long, ByVal szBuff As String) As Long
Declare Function OI_ChangerIsConfigured Lib "oasis4i" (ByVal nChanger As Long, pbIsConfigured As Long) As Long
Declare Function OI_ChangerGetType Lib "oasis4i" (ByVal nChanger As Long, pnType As Long) As Long

Declare Function OI_ChangerGetComponentCount Lib "oasis4i" (ByVal nChanger As Long, pnSubComponentCount As Long) As Long
Declare Function OI_ChangerGetComponentName Lib "oasis4i" (ByVal nChanger As Long, ByVal nComponent As Long, ByVal szBuff As String, ByVal nBuffLen As Long) As Long
Declare Function OI_ChangerSelectComponent Lib "oasis4i" (ByVal nChanger As Long, ByVal nComponent As Long) As Long
Declare Function OI_ChangerGetSelectedComponent Lib "oasis4i" (ByVal nChanger As Long, pnComponent As Long) As Long
Declare Function OI_ChangerIsComponentAvailable Lib "oasis4i" (ByVal nChanger As Long, ByVal nComponent As Long, pnStatus As Long) As Long

Declare Function OI_ChangerGetPositionName Lib "oasis4i" (ByVal nChanger As Long, ByVal nPos As Long, ByVal szBuff As String, ByVal nBuffLen As Long) As Long
Declare Function OI_ChangerGetPositionCount Lib "oasis4i" (ByVal nChanger As Long, pnCount As Long) As Long
Declare Function OI_ChangerGetPositionRange Lib "oasis4i" (ByVal nChanger As Long, pnMin As Long, pnMax As Long) As Long
Declare Function OI_ChangerMoveTo Lib "oasis4i" (ByVal nChanger As Long, ByVal nPos As Long, ByVal nWait As Long) As Long
Declare Function OI_ChangerReadPosition Lib "oasis4i" (ByVal nChanger As Long, pnPos As Long) As Long
Declare Function OI_ChangerIsMoving Lib "oasis4i" (ByVal nChanger As Long, pbMoving As Long) As Long
Declare Function OI_ChangerInit Lib "oasis4i" (ByVal nChanger As Long) As Long
Declare Function OI_ChangerOpen Lib "oasis4i" (ByVal nChanger As Long) As Long

'///////////////////////////////////////////////////////////////////////
'// Error
Declare Function OI_GetLastError Lib "oasis4i" (pnCmd As Long, pnRetCode As Long, ByVal szDesc As String, ByVal nLen As Long) As Long
Declare Function OI_EnableMsgReportDlg Lib "oasis4i" (ByVal bEnabled As Long) As Long

'///////////////////////////////////////////////////////////////////////
'// I/O
Declare Function OI_WriteIO Lib "oasis4i" (ByVal byteVal As Byte) As Long
Declare Function OI_ReadIO Lib "oasis4i" (lpbyteVal As Byte) As Long
Declare Function OI_ReadIOEx Lib "oasis4i" (ByVal nCard As Long, lpwVal As Integer) As Long
Declare Function OI_ReadInputPorts Lib "oasis4i" (lpbyVal As Byte) As Long
Declare Function OI_ReadInputPortsEx Lib "oasis4i" (ByVal nCard As Long, lpwVals As Integer) As Long

Declare Function OI_SetDAC Lib "oasis4i" (ByVal wLoadDac1 As Integer, ByVal wDac1Val As Integer, _
                                            ByVal wLoadDac2 As Integer, ByVal wDac2Val As Integer, _
                                            ByVal wLoadDac3 As Integer, ByVal wDac3Val As Integer, _
                                            ByVal wLoadDac4 As Integer, ByVal wDac4Val As Integer) As Long
                                            
Declare Function OI_ReadDAC Lib "oasis4i" (pwValuesArray As Integer) As Long

Declare Function OI_SweepDAC Lib "oasis4i" (ByVal wDacChannel As Integer, ByVal wDacTriggerMode As Integer, ByVal wDacTriggerDelayMsec As Integer, _
                                            ByVal wDacStartValue As Integer, ByVal wDacFinishValue As Integer, ByVal wDacEventCount As Integer) As Long

Declare Function OI_SetDACSweep Lib "oasis4i" (ByVal wSlices As Integer, ByVal wDacChannel As Integer, ByVal nDacIncDecValue As Long, _
                                                ByVal wTriggerSignal As Integer, ByVal wTriggerDelay As Integer, ByVal wTimerValue As Integer) As Long
Declare Function OI_GetDACSweep Lib "oasis4i" (pwSweepEnabled As Integer, pwSlices As Integer, pwDacChannel As Integer, pnDacIncDecValue As Long, _
                                                pwTriggerSignal As Integer, pwTriggerDelay As Integer, pwDelayCopy As Integer, pwTimerValue As Integer) As Long
Declare Function OI_StartDACSweep Lib "oasis4i" (ByVal bStart As Long) As Long

