using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;
using OasisLib;

namespace OasisLibSimple
{
	/// <summary>
	/// Example shoing OASIS controller library for C#
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Timer tmrPos;
		private System.Windows.Forms.Label lblPos;
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.TabPage tabStageStep;
		private System.Windows.Forms.TabPage tabStageMove;
		private System.Windows.Forms.TabPage tabStageDrive;
		private System.Windows.Forms.TabPage tabStageSettings;
		private System.Windows.Forms.Label lblStepXY;
		private System.Windows.Forms.TextBox txtStepXY;
		private System.Windows.Forms.Button btnYPos;
		private System.Windows.Forms.Button btnXPos;
		private System.Windows.Forms.Button btnXNeg;
		private System.Windows.Forms.Button btnYNeg;
		private System.Windows.Forms.TextBox txtMoveX;
		private System.Windows.Forms.TextBox txtMoveY;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button btnReadXY;
		private System.Windows.Forms.Button btnMoveXY;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Button btnDriveYNeg;
		private System.Windows.Forms.Button btnDriveYPos;
		private System.Windows.Forms.Button btnDriveXNeg;
		private System.Windows.Forms.Button btnDriveXPos;
		private System.Windows.Forms.TrackBar tbarDriveSpeed;
		private System.Windows.Forms.Button btnHaltXY;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.TabPage tabStageCal;
		private System.Windows.Forms.TextBox txtPitchX;
		private System.Windows.Forms.TextBox txtPitchY;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Button btnSetPitch;
		private System.Windows.Forms.Button btnInitXY;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.ComboBox cboRampX;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.ComboBox cboRampY;
		private System.Windows.Forms.TrackBar tbarCruiseX;
		private System.Windows.Forms.TrackBar tbarCruiseY;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.TabControl tabControl2;
		private System.Windows.Forms.TabPage tabPage1;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.Button btnZUp;
		private System.Windows.Forms.Button btnZDown;
		private System.Windows.Forms.TabPage tabPage2;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.TabPage tabPage3;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.Label label17;
		private System.Windows.Forms.Label label18;
		private System.Windows.Forms.Button btnHaltZ;
		private System.Windows.Forms.TrackBar tbarDriveZ;
		private System.Windows.Forms.Button btnDriveZDown;
		private System.Windows.Forms.Button btnDriveZUp;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.Label label20;
		private System.Windows.Forms.ComboBox cboRampZ;
		private System.Windows.Forms.GroupBox groupBox6;
		private System.Windows.Forms.Label label22;
		private System.Windows.Forms.TrackBar tbarCruiseZ;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Label label23;
		private System.Windows.Forms.Button btnInitZ;
		private System.Windows.Forms.Button btnSetPitchZ;
		private System.Windows.Forms.Label label25;
		private System.Windows.Forms.TextBox txtRangeZUp;
		private System.Windows.Forms.TextBox txtRangeZDown;
		private System.Windows.Forms.Label label19;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.TextBox txtStepZ;
		private System.Windows.Forms.Button btnMoveZ;
		private System.Windows.Forms.Button btnReadZ;
		private System.Windows.Forms.TabPage tabFocusSettings;
		private System.Windows.Forms.TabPage tabFocusCal;
		private System.Windows.Forms.TextBox txtPitchZ;
		private System.Windows.Forms.TextBox txtMoveZ;
		private System.Windows.Forms.Label lblInfo;
		private System.Windows.Forms.CheckBox chkWaitXY;
		private System.Windows.Forms.CheckBox chkWaitZ;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.lblPos = new System.Windows.Forms.Label();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.chkWaitXY = new System.Windows.Forms.CheckBox();
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tabStageStep = new System.Windows.Forms.TabPage();
			this.lblStepXY = new System.Windows.Forms.Label();
			this.txtStepXY = new System.Windows.Forms.TextBox();
			this.btnYPos = new System.Windows.Forms.Button();
			this.btnXPos = new System.Windows.Forms.Button();
			this.btnXNeg = new System.Windows.Forms.Button();
			this.btnYNeg = new System.Windows.Forms.Button();
			this.tabStageMove = new System.Windows.Forms.TabPage();
			this.btnMoveXY = new System.Windows.Forms.Button();
			this.btnReadXY = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.txtMoveY = new System.Windows.Forms.TextBox();
			this.txtMoveX = new System.Windows.Forms.TextBox();
			this.tabStageDrive = new System.Windows.Forms.TabPage();
			this.label5 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.btnHaltXY = new System.Windows.Forms.Button();
			this.tbarDriveSpeed = new System.Windows.Forms.TrackBar();
			this.btnDriveXPos = new System.Windows.Forms.Button();
			this.btnDriveXNeg = new System.Windows.Forms.Button();
			this.btnDriveYPos = new System.Windows.Forms.Button();
			this.btnDriveYNeg = new System.Windows.Forms.Button();
			this.tabStageSettings = new System.Windows.Forms.TabPage();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.label10 = new System.Windows.Forms.Label();
			this.cboRampY = new System.Windows.Forms.ComboBox();
			this.label9 = new System.Windows.Forms.Label();
			this.cboRampX = new System.Windows.Forms.ComboBox();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.label11 = new System.Windows.Forms.Label();
			this.label12 = new System.Windows.Forms.Label();
			this.tbarCruiseY = new System.Windows.Forms.TrackBar();
			this.tbarCruiseX = new System.Windows.Forms.TrackBar();
			this.tabStageCal = new System.Windows.Forms.TabPage();
			this.panel1 = new System.Windows.Forms.Panel();
			this.label8 = new System.Windows.Forms.Label();
			this.btnInitXY = new System.Windows.Forms.Button();
			this.btnSetPitch = new System.Windows.Forms.Button();
			this.label7 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.txtPitchY = new System.Windows.Forms.TextBox();
			this.txtPitchX = new System.Windows.Forms.TextBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.chkWaitZ = new System.Windows.Forms.CheckBox();
			this.tabControl2 = new System.Windows.Forms.TabControl();
			this.tabPage1 = new System.Windows.Forms.TabPage();
			this.label13 = new System.Windows.Forms.Label();
			this.txtStepZ = new System.Windows.Forms.TextBox();
			this.btnZUp = new System.Windows.Forms.Button();
			this.btnZDown = new System.Windows.Forms.Button();
			this.tabPage2 = new System.Windows.Forms.TabPage();
			this.btnMoveZ = new System.Windows.Forms.Button();
			this.btnReadZ = new System.Windows.Forms.Button();
			this.label15 = new System.Windows.Forms.Label();
			this.txtMoveZ = new System.Windows.Forms.TextBox();
			this.tabPage3 = new System.Windows.Forms.TabPage();
			this.label16 = new System.Windows.Forms.Label();
			this.label17 = new System.Windows.Forms.Label();
			this.label18 = new System.Windows.Forms.Label();
			this.btnHaltZ = new System.Windows.Forms.Button();
			this.tbarDriveZ = new System.Windows.Forms.TrackBar();
			this.btnDriveZDown = new System.Windows.Forms.Button();
			this.btnDriveZUp = new System.Windows.Forms.Button();
			this.tabFocusSettings = new System.Windows.Forms.TabPage();
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.label20 = new System.Windows.Forms.Label();
			this.cboRampZ = new System.Windows.Forms.ComboBox();
			this.groupBox6 = new System.Windows.Forms.GroupBox();
			this.label22 = new System.Windows.Forms.Label();
			this.tbarCruiseZ = new System.Windows.Forms.TrackBar();
			this.tabFocusCal = new System.Windows.Forms.TabPage();
			this.label14 = new System.Windows.Forms.Label();
			this.label19 = new System.Windows.Forms.Label();
			this.txtRangeZDown = new System.Windows.Forms.TextBox();
			this.txtRangeZUp = new System.Windows.Forms.TextBox();
			this.panel2 = new System.Windows.Forms.Panel();
			this.label23 = new System.Windows.Forms.Label();
			this.btnInitZ = new System.Windows.Forms.Button();
			this.btnSetPitchZ = new System.Windows.Forms.Button();
			this.label25 = new System.Windows.Forms.Label();
			this.txtPitchZ = new System.Windows.Forms.TextBox();
			this.tmrPos = new System.Windows.Forms.Timer(this.components);
			this.lblInfo = new System.Windows.Forms.Label();
			this.groupBox1.SuspendLayout();
			this.tabControl1.SuspendLayout();
			this.tabStageStep.SuspendLayout();
			this.tabStageMove.SuspendLayout();
			this.tabStageDrive.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.tbarDriveSpeed)).BeginInit();
			this.tabStageSettings.SuspendLayout();
			this.groupBox4.SuspendLayout();
			this.groupBox3.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.tbarCruiseY)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.tbarCruiseX)).BeginInit();
			this.tabStageCal.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.tabControl2.SuspendLayout();
			this.tabPage1.SuspendLayout();
			this.tabPage2.SuspendLayout();
			this.tabPage3.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.tbarDriveZ)).BeginInit();
			this.tabFocusSettings.SuspendLayout();
			this.groupBox5.SuspendLayout();
			this.groupBox6.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.tbarCruiseZ)).BeginInit();
			this.tabFocusCal.SuspendLayout();
			this.SuspendLayout();
			// 
			// lblPos
			// 
			this.lblPos.BackColor = System.Drawing.Color.Black;
			this.lblPos.Font = new System.Drawing.Font("Courier New", 15.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblPos.ForeColor = System.Drawing.Color.Lime;
			this.lblPos.Location = new System.Drawing.Point(16, 8);
			this.lblPos.Name = "lblPos";
			this.lblPos.Size = new System.Drawing.Size(224, 88);
			this.lblPos.TabIndex = 0;
			this.lblPos.Text = "0";
			this.lblPos.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.chkWaitXY);
			this.groupBox1.Controls.Add(this.tabControl1);
			this.groupBox1.Location = new System.Drawing.Point(8, 104);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(240, 312);
			this.groupBox1.TabIndex = 1;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Stage";
			// 
			// chkWaitXY
			// 
			this.chkWaitXY.Location = new System.Drawing.Point(16, 288);
			this.chkWaitXY.Name = "chkWaitXY";
			this.chkWaitXY.Size = new System.Drawing.Size(176, 16);
			this.chkWaitXY.TabIndex = 19;
			this.chkWaitXY.Text = "Wait for moves to complete";
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.tabStageStep);
			this.tabControl1.Controls.Add(this.tabStageMove);
			this.tabControl1.Controls.Add(this.tabStageDrive);
			this.tabControl1.Controls.Add(this.tabStageSettings);
			this.tabControl1.Controls.Add(this.tabStageCal);
			this.tabControl1.Location = new System.Drawing.Point(8, 16);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(224, 264);
			this.tabControl1.TabIndex = 8;
			// 
			// tabStageStep
			// 
			this.tabStageStep.Controls.Add(this.lblStepXY);
			this.tabStageStep.Controls.Add(this.txtStepXY);
			this.tabStageStep.Controls.Add(this.btnYPos);
			this.tabStageStep.Controls.Add(this.btnXPos);
			this.tabStageStep.Controls.Add(this.btnXNeg);
			this.tabStageStep.Controls.Add(this.btnYNeg);
			this.tabStageStep.Location = new System.Drawing.Point(4, 22);
			this.tabStageStep.Name = "tabStageStep";
			this.tabStageStep.Size = new System.Drawing.Size(216, 238);
			this.tabStageStep.TabIndex = 0;
			this.tabStageStep.Text = "Step";
			// 
			// lblStepXY
			// 
			this.lblStepXY.Location = new System.Drawing.Point(24, 131);
			this.lblStepXY.Name = "lblStepXY";
			this.lblStepXY.Size = new System.Drawing.Size(88, 21);
			this.lblStepXY.TabIndex = 17;
			this.lblStepXY.Text = "Step size (m):";
			this.lblStepXY.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// txtStepXY
			// 
			this.txtStepXY.Location = new System.Drawing.Point(120, 131);
			this.txtStepXY.Name = "txtStepXY";
			this.txtStepXY.Size = new System.Drawing.Size(56, 20);
			this.txtStepXY.TabIndex = 16;
			this.txtStepXY.Text = "500";
			// 
			// btnYPos
			// 
			this.btnYPos.Location = new System.Drawing.Point(80, 88);
			this.btnYPos.Name = "btnYPos";
			this.btnYPos.Size = new System.Drawing.Size(56, 24);
			this.btnYPos.TabIndex = 15;
			this.btnYPos.Text = "Y Pos";
			this.btnYPos.Click += new System.EventHandler(this.btnYPos_Click);
			// 
			// btnXPos
			// 
			this.btnXPos.Location = new System.Drawing.Point(144, 56);
			this.btnXPos.Name = "btnXPos";
			this.btnXPos.Size = new System.Drawing.Size(56, 24);
			this.btnXPos.TabIndex = 14;
			this.btnXPos.Text = "X Pos";
			this.btnXPos.Click += new System.EventHandler(this.btnXPos_Click);
			// 
			// btnXNeg
			// 
			this.btnXNeg.Location = new System.Drawing.Point(16, 56);
			this.btnXNeg.Name = "btnXNeg";
			this.btnXNeg.Size = new System.Drawing.Size(56, 24);
			this.btnXNeg.TabIndex = 13;
			this.btnXNeg.Text = "X Neg";
			this.btnXNeg.Click += new System.EventHandler(this.btnXNeg_Click);
			// 
			// btnYNeg
			// 
			this.btnYNeg.Location = new System.Drawing.Point(80, 24);
			this.btnYNeg.Name = "btnYNeg";
			this.btnYNeg.Size = new System.Drawing.Size(56, 24);
			this.btnYNeg.TabIndex = 12;
			this.btnYNeg.Text = "Y Neg";
			this.btnYNeg.Click += new System.EventHandler(this.btnYNeg_Click);
			// 
			// tabStageMove
			// 
			this.tabStageMove.Controls.Add(this.btnMoveXY);
			this.tabStageMove.Controls.Add(this.btnReadXY);
			this.tabStageMove.Controls.Add(this.label2);
			this.tabStageMove.Controls.Add(this.label1);
			this.tabStageMove.Controls.Add(this.txtMoveY);
			this.tabStageMove.Controls.Add(this.txtMoveX);
			this.tabStageMove.Location = new System.Drawing.Point(4, 22);
			this.tabStageMove.Name = "tabStageMove";
			this.tabStageMove.Size = new System.Drawing.Size(216, 238);
			this.tabStageMove.TabIndex = 1;
			this.tabStageMove.Text = "Move";
			// 
			// btnMoveXY
			// 
			this.btnMoveXY.Location = new System.Drawing.Point(48, 128);
			this.btnMoveXY.Name = "btnMoveXY";
			this.btnMoveXY.Size = new System.Drawing.Size(112, 24);
			this.btnMoveXY.TabIndex = 5;
			this.btnMoveXY.Text = "Move to XY";
			this.btnMoveXY.Click += new System.EventHandler(this.btnMoveXY_Click);
			// 
			// btnReadXY
			// 
			this.btnReadXY.Location = new System.Drawing.Point(48, 96);
			this.btnReadXY.Name = "btnReadXY";
			this.btnReadXY.Size = new System.Drawing.Size(112, 24);
			this.btnReadXY.TabIndex = 4;
			this.btnReadXY.Text = "Read XY";
			this.btnReadXY.Click += new System.EventHandler(this.btnReadXY_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(24, 56);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(72, 16);
			this.label2.TabIndex = 3;
			this.label2.Text = "Y (m):";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(24, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "X (m):";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// txtMoveY
			// 
			this.txtMoveY.Location = new System.Drawing.Point(104, 56);
			this.txtMoveY.Name = "txtMoveY";
			this.txtMoveY.Size = new System.Drawing.Size(96, 20);
			this.txtMoveY.TabIndex = 1;
			this.txtMoveY.Text = "";
			// 
			// txtMoveX
			// 
			this.txtMoveX.Location = new System.Drawing.Point(104, 32);
			this.txtMoveX.Name = "txtMoveX";
			this.txtMoveX.Size = new System.Drawing.Size(96, 20);
			this.txtMoveX.TabIndex = 0;
			this.txtMoveX.Text = "";
			// 
			// tabStageDrive
			// 
			this.tabStageDrive.Controls.Add(this.label5);
			this.tabStageDrive.Controls.Add(this.label4);
			this.tabStageDrive.Controls.Add(this.label3);
			this.tabStageDrive.Controls.Add(this.btnHaltXY);
			this.tabStageDrive.Controls.Add(this.tbarDriveSpeed);
			this.tabStageDrive.Controls.Add(this.btnDriveXPos);
			this.tabStageDrive.Controls.Add(this.btnDriveXNeg);
			this.tabStageDrive.Controls.Add(this.btnDriveYPos);
			this.tabStageDrive.Controls.Add(this.btnDriveYNeg);
			this.tabStageDrive.Location = new System.Drawing.Point(4, 22);
			this.tabStageDrive.Name = "tabStageDrive";
			this.tabStageDrive.Size = new System.Drawing.Size(216, 238);
			this.tabStageDrive.TabIndex = 2;
			this.tabStageDrive.Text = "Drive";
			// 
			// label5
			// 
			this.label5.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.label5.Location = new System.Drawing.Point(144, 160);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(56, 16);
			this.label5.TabIndex = 8;
			this.label5.Text = "Fast";
			this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 160);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(56, 16);
			this.label4.TabIndex = 7;
			this.label4.Text = "Slow";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 8);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(192, 32);
			this.label3.TabIndex = 6;
			this.label3.Text = "Click and hold down a button to drive the stage";
			// 
			// btnHaltXY
			// 
			this.btnHaltXY.Location = new System.Drawing.Point(80, 88);
			this.btnHaltXY.Name = "btnHaltXY";
			this.btnHaltXY.Size = new System.Drawing.Size(56, 24);
			this.btnHaltXY.TabIndex = 5;
			this.btnHaltXY.Text = "HALT!";
			this.btnHaltXY.Click += new System.EventHandler(this.btnHaltXY_Click);
			// 
			// tbarDriveSpeed
			// 
			this.tbarDriveSpeed.Location = new System.Drawing.Point(8, 184);
			this.tbarDriveSpeed.Maximum = 4095;
			this.tbarDriveSpeed.Minimum = 1;
			this.tbarDriveSpeed.Name = "tbarDriveSpeed";
			this.tbarDriveSpeed.Size = new System.Drawing.Size(200, 45);
			this.tbarDriveSpeed.TabIndex = 4;
			this.tbarDriveSpeed.TickFrequency = 256;
			this.tbarDriveSpeed.Value = 1024;
			// 
			// btnDriveXPos
			// 
			this.btnDriveXPos.Location = new System.Drawing.Point(144, 88);
			this.btnDriveXPos.Name = "btnDriveXPos";
			this.btnDriveXPos.Size = new System.Drawing.Size(56, 24);
			this.btnDriveXPos.TabIndex = 3;
			this.btnDriveXPos.Text = "X Pos";
			this.btnDriveXPos.MouseUp += new System.Windows.Forms.MouseEventHandler(this.btnDriveXPos_MouseUp);
			this.btnDriveXPos.MouseDown += new System.Windows.Forms.MouseEventHandler(this.btnDriveXPos_MouseDown);
			// 
			// btnDriveXNeg
			// 
			this.btnDriveXNeg.Location = new System.Drawing.Point(16, 88);
			this.btnDriveXNeg.Name = "btnDriveXNeg";
			this.btnDriveXNeg.Size = new System.Drawing.Size(56, 24);
			this.btnDriveXNeg.TabIndex = 2;
			this.btnDriveXNeg.Text = "X Neg";
			this.btnDriveXNeg.MouseUp += new System.Windows.Forms.MouseEventHandler(this.btnDriveXNeg_MouseUp);
			this.btnDriveXNeg.MouseDown += new System.Windows.Forms.MouseEventHandler(this.btnDriveXNeg_MouseDown);
			// 
			// btnDriveYPos
			// 
			this.btnDriveYPos.Location = new System.Drawing.Point(80, 120);
			this.btnDriveYPos.Name = "btnDriveYPos";
			this.btnDriveYPos.Size = new System.Drawing.Size(56, 24);
			this.btnDriveYPos.TabIndex = 1;
			this.btnDriveYPos.Text = "Y Pos";
			this.btnDriveYPos.MouseUp += new System.Windows.Forms.MouseEventHandler(this.btnDriveYPos_MouseUp);
			this.btnDriveYPos.MouseDown += new System.Windows.Forms.MouseEventHandler(this.btnDriveYPos_MouseDown);
			// 
			// btnDriveYNeg
			// 
			this.btnDriveYNeg.Location = new System.Drawing.Point(80, 56);
			this.btnDriveYNeg.Name = "btnDriveYNeg";
			this.btnDriveYNeg.Size = new System.Drawing.Size(56, 24);
			this.btnDriveYNeg.TabIndex = 0;
			this.btnDriveYNeg.Text = "Y Neg";
			this.btnDriveYNeg.MouseUp += new System.Windows.Forms.MouseEventHandler(this.btnDriveYNeg_MouseUp);
			this.btnDriveYNeg.MouseDown += new System.Windows.Forms.MouseEventHandler(this.btnDriveYNeg_MouseDown);
			// 
			// tabStageSettings
			// 
			this.tabStageSettings.Controls.Add(this.groupBox4);
			this.tabStageSettings.Controls.Add(this.groupBox3);
			this.tabStageSettings.Location = new System.Drawing.Point(4, 22);
			this.tabStageSettings.Name = "tabStageSettings";
			this.tabStageSettings.Size = new System.Drawing.Size(216, 238);
			this.tabStageSettings.TabIndex = 3;
			this.tabStageSettings.Text = "Settings";
			this.tabStageSettings.Layout += new System.Windows.Forms.LayoutEventHandler(this.tabStageSettings_Layout);
			// 
			// groupBox4
			// 
			this.groupBox4.Controls.Add(this.label10);
			this.groupBox4.Controls.Add(this.cboRampY);
			this.groupBox4.Controls.Add(this.label9);
			this.groupBox4.Controls.Add(this.cboRampX);
			this.groupBox4.Location = new System.Drawing.Point(8, 128);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(200, 96);
			this.groupBox4.TabIndex = 10;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "Ramps";
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(8, 56);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(56, 24);
			this.label10.TabIndex = 3;
			this.label10.Text = "Y-Axis:";
			this.label10.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// cboRampY
			// 
			this.cboRampY.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboRampY.Items.AddRange(new object[] {
														  "Slow",
														  "Normal",
														  "Fast",
														  "User"});
			this.cboRampY.Location = new System.Drawing.Point(80, 56);
			this.cboRampY.Name = "cboRampY";
			this.cboRampY.Size = new System.Drawing.Size(112, 21);
			this.cboRampY.TabIndex = 2;
			this.cboRampY.SelectedIndexChanged += new System.EventHandler(this.cboRampY_SelectedIndexChanged);
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(8, 24);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(56, 24);
			this.label9.TabIndex = 1;
			this.label9.Text = "X-Axis:";
			this.label9.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// cboRampX
			// 
			this.cboRampX.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboRampX.Items.AddRange(new object[] {
														  "Slow",
														  "Normal",
														  "Fast",
														  "User"});
			this.cboRampX.Location = new System.Drawing.Point(80, 24);
			this.cboRampX.Name = "cboRampX";
			this.cboRampX.Size = new System.Drawing.Size(112, 21);
			this.cboRampX.TabIndex = 0;
			this.cboRampX.SelectedIndexChanged += new System.EventHandler(this.cboRampX_SelectedIndexChanged);
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.label11);
			this.groupBox3.Controls.Add(this.label12);
			this.groupBox3.Controls.Add(this.tbarCruiseY);
			this.groupBox3.Controls.Add(this.tbarCruiseX);
			this.groupBox3.Location = new System.Drawing.Point(8, 8);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(200, 112);
			this.groupBox3.TabIndex = 9;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Cruise Speeds";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(8, 64);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(56, 24);
			this.label11.TabIndex = 13;
			this.label11.Text = "Y-Axis:";
			this.label11.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(8, 24);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(56, 24);
			this.label12.TabIndex = 12;
			this.label12.Text = "X-Axis:";
			this.label12.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// tbarCruiseY
			// 
			this.tbarCruiseY.AutoSize = false;
			this.tbarCruiseY.Location = new System.Drawing.Point(72, 64);
			this.tbarCruiseY.Maximum = 511;
			this.tbarCruiseY.Name = "tbarCruiseY";
			this.tbarCruiseY.Size = new System.Drawing.Size(120, 32);
			this.tbarCruiseY.TabIndex = 11;
			this.tbarCruiseY.TickFrequency = 64;
			this.tbarCruiseY.ValueChanged += new System.EventHandler(this.tbarCruiseY_ValueChanged);
			// 
			// tbarCruiseX
			// 
			this.tbarCruiseX.AutoSize = false;
			this.tbarCruiseX.Location = new System.Drawing.Point(72, 24);
			this.tbarCruiseX.Maximum = 511;
			this.tbarCruiseX.Name = "tbarCruiseX";
			this.tbarCruiseX.Size = new System.Drawing.Size(120, 32);
			this.tbarCruiseX.TabIndex = 10;
			this.tbarCruiseX.TickFrequency = 64;
			this.tbarCruiseX.ValueChanged += new System.EventHandler(this.tbarCruiseX_ValueChanged);
			// 
			// tabStageCal
			// 
			this.tabStageCal.Controls.Add(this.panel1);
			this.tabStageCal.Controls.Add(this.label8);
			this.tabStageCal.Controls.Add(this.btnInitXY);
			this.tabStageCal.Controls.Add(this.btnSetPitch);
			this.tabStageCal.Controls.Add(this.label7);
			this.tabStageCal.Controls.Add(this.label6);
			this.tabStageCal.Controls.Add(this.txtPitchY);
			this.tabStageCal.Controls.Add(this.txtPitchX);
			this.tabStageCal.Location = new System.Drawing.Point(4, 22);
			this.tabStageCal.Name = "tabStageCal";
			this.tabStageCal.Size = new System.Drawing.Size(216, 238);
			this.tabStageCal.TabIndex = 4;
			this.tabStageCal.Text = "Cal";
			this.tabStageCal.Layout += new System.Windows.Forms.LayoutEventHandler(this.tabStageCal_Layout);
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.SystemColors.ControlDark;
			this.panel1.Location = new System.Drawing.Point(8, 104);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(200, 2);
			this.panel1.TabIndex = 11;
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(16, 8);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(176, 48);
			this.label8.TabIndex = 10;
			this.label8.Text = "Click Initialize to home the stage by moving to the limits of travel in X and Y.";
			// 
			// btnInitXY
			// 
			this.btnInitXY.Location = new System.Drawing.Point(56, 64);
			this.btnInitXY.Name = "btnInitXY";
			this.btnInitXY.Size = new System.Drawing.Size(104, 24);
			this.btnInitXY.TabIndex = 9;
			this.btnInitXY.Text = "Initialize...";
			this.btnInitXY.Click += new System.EventHandler(this.btnInitXY_Click);
			// 
			// btnSetPitch
			// 
			this.btnSetPitch.Location = new System.Drawing.Point(64, 192);
			this.btnSetPitch.Name = "btnSetPitch";
			this.btnSetPitch.Size = new System.Drawing.Size(104, 24);
			this.btnSetPitch.TabIndex = 4;
			this.btnSetPitch.Text = "Set Pitch";
			this.btnSetPitch.Click += new System.EventHandler(this.btnSetPitch_Click);
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(16, 160);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(112, 16);
			this.label7.TabIndex = 3;
			this.label7.Text = "Y-Axis pitch (mm):";
			this.label7.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(16, 128);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(112, 16);
			this.label6.TabIndex = 2;
			this.label6.Text = "X-Axis pitch (mm):";
			this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// txtPitchY
			// 
			this.txtPitchY.Location = new System.Drawing.Point(144, 160);
			this.txtPitchY.Name = "txtPitchY";
			this.txtPitchY.Size = new System.Drawing.Size(56, 20);
			this.txtPitchY.TabIndex = 1;
			this.txtPitchY.Text = "1.0";
			this.txtPitchY.TextChanged += new System.EventHandler(this.txtPitchY_TextChanged);
			// 
			// txtPitchX
			// 
			this.txtPitchX.Location = new System.Drawing.Point(144, 128);
			this.txtPitchX.Name = "txtPitchX";
			this.txtPitchX.Size = new System.Drawing.Size(56, 20);
			this.txtPitchX.TabIndex = 0;
			this.txtPitchX.Text = "1.0";
			this.txtPitchX.TextChanged += new System.EventHandler(this.txtPitchX_TextChanged);
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.chkWaitZ);
			this.groupBox2.Controls.Add(this.tabControl2);
			this.groupBox2.Location = new System.Drawing.Point(256, 104);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(248, 312);
			this.groupBox2.TabIndex = 2;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Focus";
			// 
			// chkWaitZ
			// 
			this.chkWaitZ.Location = new System.Drawing.Point(16, 288);
			this.chkWaitZ.Name = "chkWaitZ";
			this.chkWaitZ.Size = new System.Drawing.Size(176, 16);
			this.chkWaitZ.TabIndex = 19;
			this.chkWaitZ.Text = "Wait for moves to complete";
			// 
			// tabControl2
			// 
			this.tabControl2.Controls.Add(this.tabPage1);
			this.tabControl2.Controls.Add(this.tabPage2);
			this.tabControl2.Controls.Add(this.tabPage3);
			this.tabControl2.Controls.Add(this.tabFocusSettings);
			this.tabControl2.Controls.Add(this.tabFocusCal);
			this.tabControl2.Location = new System.Drawing.Point(8, 16);
			this.tabControl2.Name = "tabControl2";
			this.tabControl2.SelectedIndex = 0;
			this.tabControl2.Size = new System.Drawing.Size(224, 264);
			this.tabControl2.TabIndex = 9;
			// 
			// tabPage1
			// 
			this.tabPage1.Controls.Add(this.label13);
			this.tabPage1.Controls.Add(this.txtStepZ);
			this.tabPage1.Controls.Add(this.btnZUp);
			this.tabPage1.Controls.Add(this.btnZDown);
			this.tabPage1.Location = new System.Drawing.Point(4, 22);
			this.tabPage1.Name = "tabPage1";
			this.tabPage1.Size = new System.Drawing.Size(216, 238);
			this.tabPage1.TabIndex = 0;
			this.tabPage1.Text = "Step";
			// 
			// label13
			// 
			this.label13.Location = new System.Drawing.Point(24, 131);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(88, 21);
			this.label13.TabIndex = 17;
			this.label13.Text = "Step size (m):";
			this.label13.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// txtStepZ
			// 
			this.txtStepZ.Location = new System.Drawing.Point(120, 131);
			this.txtStepZ.Name = "txtStepZ";
			this.txtStepZ.Size = new System.Drawing.Size(56, 20);
			this.txtStepZ.TabIndex = 16;
			this.txtStepZ.Text = "25";
			// 
			// btnZUp
			// 
			this.btnZUp.Location = new System.Drawing.Point(64, 32);
			this.btnZUp.Name = "btnZUp";
			this.btnZUp.Size = new System.Drawing.Size(96, 24);
			this.btnZUp.TabIndex = 15;
			this.btnZUp.Text = "Up";
			this.btnZUp.Click += new System.EventHandler(this.btnZUp_Click);
			// 
			// btnZDown
			// 
			this.btnZDown.Location = new System.Drawing.Point(64, 72);
			this.btnZDown.Name = "btnZDown";
			this.btnZDown.Size = new System.Drawing.Size(96, 24);
			this.btnZDown.TabIndex = 12;
			this.btnZDown.Text = "Down";
			this.btnZDown.Click += new System.EventHandler(this.btnZDown_Click);
			// 
			// tabPage2
			// 
			this.tabPage2.Controls.Add(this.btnMoveZ);
			this.tabPage2.Controls.Add(this.btnReadZ);
			this.tabPage2.Controls.Add(this.label15);
			this.tabPage2.Controls.Add(this.txtMoveZ);
			this.tabPage2.Location = new System.Drawing.Point(4, 22);
			this.tabPage2.Name = "tabPage2";
			this.tabPage2.Size = new System.Drawing.Size(216, 238);
			this.tabPage2.TabIndex = 1;
			this.tabPage2.Text = "Move";
			this.tabPage2.Visible = false;
			// 
			// btnMoveZ
			// 
			this.btnMoveZ.Location = new System.Drawing.Point(48, 112);
			this.btnMoveZ.Name = "btnMoveZ";
			this.btnMoveZ.Size = new System.Drawing.Size(112, 24);
			this.btnMoveZ.TabIndex = 5;
			this.btnMoveZ.Text = "Move to Z";
			this.btnMoveZ.Click += new System.EventHandler(this.btnMoveZ_Click);
			// 
			// btnReadZ
			// 
			this.btnReadZ.Location = new System.Drawing.Point(48, 72);
			this.btnReadZ.Name = "btnReadZ";
			this.btnReadZ.Size = new System.Drawing.Size(112, 24);
			this.btnReadZ.TabIndex = 4;
			this.btnReadZ.Text = "Read Z";
			this.btnReadZ.Click += new System.EventHandler(this.btnReadZ_Click);
			// 
			// label15
			// 
			this.label15.Location = new System.Drawing.Point(16, 32);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(72, 16);
			this.label15.TabIndex = 2;
			this.label15.Text = "Z (m):";
			this.label15.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// txtMoveZ
			// 
			this.txtMoveZ.Location = new System.Drawing.Point(104, 32);
			this.txtMoveZ.Name = "txtMoveZ";
			this.txtMoveZ.Size = new System.Drawing.Size(96, 20);
			this.txtMoveZ.TabIndex = 0;
			this.txtMoveZ.Text = "";
			// 
			// tabPage3
			// 
			this.tabPage3.Controls.Add(this.label16);
			this.tabPage3.Controls.Add(this.label17);
			this.tabPage3.Controls.Add(this.label18);
			this.tabPage3.Controls.Add(this.btnHaltZ);
			this.tabPage3.Controls.Add(this.tbarDriveZ);
			this.tabPage3.Controls.Add(this.btnDriveZDown);
			this.tabPage3.Controls.Add(this.btnDriveZUp);
			this.tabPage3.Location = new System.Drawing.Point(4, 22);
			this.tabPage3.Name = "tabPage3";
			this.tabPage3.Size = new System.Drawing.Size(216, 238);
			this.tabPage3.TabIndex = 2;
			this.tabPage3.Text = "Drive";
			this.tabPage3.Visible = false;
			// 
			// label16
			// 
			this.label16.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.label16.Location = new System.Drawing.Point(144, 160);
			this.label16.Name = "label16";
			this.label16.Size = new System.Drawing.Size(56, 16);
			this.label16.TabIndex = 8;
			this.label16.Text = "Fast";
			this.label16.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label17
			// 
			this.label17.Location = new System.Drawing.Point(16, 160);
			this.label17.Name = "label17";
			this.label17.Size = new System.Drawing.Size(56, 16);
			this.label17.TabIndex = 7;
			this.label17.Text = "Slow";
			this.label17.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// label18
			// 
			this.label18.Location = new System.Drawing.Point(16, 8);
			this.label18.Name = "label18";
			this.label18.Size = new System.Drawing.Size(192, 32);
			this.label18.TabIndex = 6;
			this.label18.Text = "Click and hold down a button to drive the focus";
			// 
			// btnHaltZ
			// 
			this.btnHaltZ.Location = new System.Drawing.Point(56, 88);
			this.btnHaltZ.Name = "btnHaltZ";
			this.btnHaltZ.Size = new System.Drawing.Size(96, 24);
			this.btnHaltZ.TabIndex = 5;
			this.btnHaltZ.Text = "HALT!";
			this.btnHaltZ.Click += new System.EventHandler(this.btnHaltZ_Click);
			// 
			// tbarDriveZ
			// 
			this.tbarDriveZ.Location = new System.Drawing.Point(8, 184);
			this.tbarDriveZ.Maximum = 4095;
			this.tbarDriveZ.Minimum = 1;
			this.tbarDriveZ.Name = "tbarDriveZ";
			this.tbarDriveZ.Size = new System.Drawing.Size(200, 45);
			this.tbarDriveZ.TabIndex = 4;
			this.tbarDriveZ.TickFrequency = 256;
			this.tbarDriveZ.Value = 1024;
			// 
			// btnDriveZDown
			// 
			this.btnDriveZDown.Location = new System.Drawing.Point(56, 120);
			this.btnDriveZDown.Name = "btnDriveZDown";
			this.btnDriveZDown.Size = new System.Drawing.Size(96, 24);
			this.btnDriveZDown.TabIndex = 1;
			this.btnDriveZDown.Text = "Z Down";
			this.btnDriveZDown.MouseUp += new System.Windows.Forms.MouseEventHandler(this.btnDriveZDown_MouseUp);
			this.btnDriveZDown.MouseDown += new System.Windows.Forms.MouseEventHandler(this.btnDriveZDown_MouseDown);
			// 
			// btnDriveZUp
			// 
			this.btnDriveZUp.Location = new System.Drawing.Point(56, 56);
			this.btnDriveZUp.Name = "btnDriveZUp";
			this.btnDriveZUp.Size = new System.Drawing.Size(96, 24);
			this.btnDriveZUp.TabIndex = 0;
			this.btnDriveZUp.Text = "Z Up";
			this.btnDriveZUp.MouseUp += new System.Windows.Forms.MouseEventHandler(this.btnDriveZUp_MouseUp);
			this.btnDriveZUp.MouseDown += new System.Windows.Forms.MouseEventHandler(this.btnDriveZUp_MouseDown);
			// 
			// tabFocusSettings
			// 
			this.tabFocusSettings.Controls.Add(this.groupBox5);
			this.tabFocusSettings.Controls.Add(this.groupBox6);
			this.tabFocusSettings.Location = new System.Drawing.Point(4, 22);
			this.tabFocusSettings.Name = "tabFocusSettings";
			this.tabFocusSettings.Size = new System.Drawing.Size(216, 238);
			this.tabFocusSettings.TabIndex = 3;
			this.tabFocusSettings.Text = "Settings";
			this.tabFocusSettings.Visible = false;
			this.tabFocusSettings.Layout += new System.Windows.Forms.LayoutEventHandler(this.tabFocusSettings_Layout);
			// 
			// groupBox5
			// 
			this.groupBox5.Controls.Add(this.label20);
			this.groupBox5.Controls.Add(this.cboRampZ);
			this.groupBox5.Location = new System.Drawing.Point(8, 128);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(200, 96);
			this.groupBox5.TabIndex = 10;
			this.groupBox5.TabStop = false;
			this.groupBox5.Text = "Ramps";
			// 
			// label20
			// 
			this.label20.Location = new System.Drawing.Point(8, 40);
			this.label20.Name = "label20";
			this.label20.Size = new System.Drawing.Size(56, 24);
			this.label20.TabIndex = 1;
			this.label20.Text = "Z-Axis:";
			this.label20.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// cboRampZ
			// 
			this.cboRampZ.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboRampZ.Items.AddRange(new object[] {
														  "Slow",
														  "Normal",
														  "Fast",
														  "User"});
			this.cboRampZ.Location = new System.Drawing.Point(80, 40);
			this.cboRampZ.Name = "cboRampZ";
			this.cboRampZ.Size = new System.Drawing.Size(112, 21);
			this.cboRampZ.TabIndex = 0;
			this.cboRampZ.SelectedIndexChanged += new System.EventHandler(this.cboRampZ_SelectedIndexChanged);
			// 
			// groupBox6
			// 
			this.groupBox6.Controls.Add(this.label22);
			this.groupBox6.Controls.Add(this.tbarCruiseZ);
			this.groupBox6.Location = new System.Drawing.Point(8, 8);
			this.groupBox6.Name = "groupBox6";
			this.groupBox6.Size = new System.Drawing.Size(200, 112);
			this.groupBox6.TabIndex = 9;
			this.groupBox6.TabStop = false;
			this.groupBox6.Text = "Cruise Speeds";
			// 
			// label22
			// 
			this.label22.Location = new System.Drawing.Point(8, 48);
			this.label22.Name = "label22";
			this.label22.Size = new System.Drawing.Size(56, 24);
			this.label22.TabIndex = 12;
			this.label22.Text = "Z-Axis:";
			this.label22.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// tbarCruiseZ
			// 
			this.tbarCruiseZ.AutoSize = false;
			this.tbarCruiseZ.Location = new System.Drawing.Point(72, 48);
			this.tbarCruiseZ.Maximum = 511;
			this.tbarCruiseZ.Name = "tbarCruiseZ";
			this.tbarCruiseZ.Size = new System.Drawing.Size(120, 32);
			this.tbarCruiseZ.TabIndex = 10;
			this.tbarCruiseZ.TickFrequency = 64;
			this.tbarCruiseZ.ValueChanged += new System.EventHandler(this.tbarCruiseZ_ValueChanged);
			// 
			// tabFocusCal
			// 
			this.tabFocusCal.Controls.Add(this.label14);
			this.tabFocusCal.Controls.Add(this.label19);
			this.tabFocusCal.Controls.Add(this.txtRangeZDown);
			this.tabFocusCal.Controls.Add(this.txtRangeZUp);
			this.tabFocusCal.Controls.Add(this.panel2);
			this.tabFocusCal.Controls.Add(this.label23);
			this.tabFocusCal.Controls.Add(this.btnInitZ);
			this.tabFocusCal.Controls.Add(this.btnSetPitchZ);
			this.tabFocusCal.Controls.Add(this.label25);
			this.tabFocusCal.Controls.Add(this.txtPitchZ);
			this.tabFocusCal.Location = new System.Drawing.Point(4, 22);
			this.tabFocusCal.Name = "tabFocusCal";
			this.tabFocusCal.Size = new System.Drawing.Size(216, 238);
			this.tabFocusCal.TabIndex = 4;
			this.tabFocusCal.Text = "Cal";
			this.tabFocusCal.Visible = false;
			this.tabFocusCal.Layout += new System.Windows.Forms.LayoutEventHandler(this.tabFocusCal_Layout);
			// 
			// label14
			// 
			this.label14.Location = new System.Drawing.Point(8, 88);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(112, 16);
			this.label14.TabIndex = 16;
			this.label14.Text = "Range below (m):";
			this.label14.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label19
			// 
			this.label19.Location = new System.Drawing.Point(8, 64);
			this.label19.Name = "label19";
			this.label19.Size = new System.Drawing.Size(112, 16);
			this.label19.TabIndex = 15;
			this.label19.Text = "Range above (m):";
			this.label19.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// txtRangeZDown
			// 
			this.txtRangeZDown.Location = new System.Drawing.Point(128, 88);
			this.txtRangeZDown.Name = "txtRangeZDown";
			this.txtRangeZDown.Size = new System.Drawing.Size(72, 20);
			this.txtRangeZDown.TabIndex = 13;
			this.txtRangeZDown.Text = "5000";
			// 
			// txtRangeZUp
			// 
			this.txtRangeZUp.Location = new System.Drawing.Point(128, 64);
			this.txtRangeZUp.Name = "txtRangeZUp";
			this.txtRangeZUp.Size = new System.Drawing.Size(72, 20);
			this.txtRangeZUp.TabIndex = 12;
			this.txtRangeZUp.Text = "1000";
			// 
			// panel2
			// 
			this.panel2.BackColor = System.Drawing.SystemColors.ControlDark;
			this.panel2.Location = new System.Drawing.Point(8, 152);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(200, 2);
			this.panel2.TabIndex = 11;
			// 
			// label23
			// 
			this.label23.Location = new System.Drawing.Point(16, 8);
			this.label23.Name = "label23";
			this.label23.Size = new System.Drawing.Size(184, 48);
			this.label23.TabIndex = 10;
			this.label23.Text = "Set the range of travel the current focus position and click Initialize to define" +
				" origin and range.";
			// 
			// btnInitZ
			// 
			this.btnInitZ.Location = new System.Drawing.Point(64, 120);
			this.btnInitZ.Name = "btnInitZ";
			this.btnInitZ.Size = new System.Drawing.Size(104, 24);
			this.btnInitZ.TabIndex = 9;
			this.btnInitZ.Text = "Initialize";
			this.btnInitZ.Click += new System.EventHandler(this.btnInitZ_Click);
			// 
			// btnSetPitchZ
			// 
			this.btnSetPitchZ.Location = new System.Drawing.Point(64, 200);
			this.btnSetPitchZ.Name = "btnSetPitchZ";
			this.btnSetPitchZ.Size = new System.Drawing.Size(104, 24);
			this.btnSetPitchZ.TabIndex = 4;
			this.btnSetPitchZ.Text = "Set Pitch";
			// 
			// label25
			// 
			this.label25.Location = new System.Drawing.Point(16, 168);
			this.label25.Name = "label25";
			this.label25.Size = new System.Drawing.Size(112, 16);
			this.label25.TabIndex = 2;
			this.label25.Text = "Z-Axis pitch (mm):";
			this.label25.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// txtPitchZ
			// 
			this.txtPitchZ.Location = new System.Drawing.Point(144, 168);
			this.txtPitchZ.Name = "txtPitchZ";
			this.txtPitchZ.Size = new System.Drawing.Size(56, 20);
			this.txtPitchZ.TabIndex = 0;
			this.txtPitchZ.Text = "0.1";
			// 
			// tmrPos
			// 
			this.tmrPos.Enabled = true;
			this.tmrPos.Interval = 50;
			this.tmrPos.Tick += new System.EventHandler(this.tmrPos_Tick);
			// 
			// lblInfo
			// 
			this.lblInfo.Location = new System.Drawing.Point(248, 8);
			this.lblInfo.Name = "lblInfo";
			this.lblInfo.Size = new System.Drawing.Size(256, 88);
			this.lblInfo.TabIndex = 3;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(512, 432);
			this.Controls.Add(this.lblInfo);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.lblPos);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "OASIS Controller";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.Closed += new System.EventHandler(this.Form1_Closed);
			this.groupBox1.ResumeLayout(false);
			this.tabControl1.ResumeLayout(false);
			this.tabStageStep.ResumeLayout(false);
			this.tabStageMove.ResumeLayout(false);
			this.tabStageDrive.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.tbarDriveSpeed)).EndInit();
			this.tabStageSettings.ResumeLayout(false);
			this.groupBox4.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.tbarCruiseY)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.tbarCruiseX)).EndInit();
			this.tabStageCal.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.tabControl2.ResumeLayout(false);
			this.tabPage1.ResumeLayout(false);
			this.tabPage2.ResumeLayout(false);
			this.tabPage3.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.tbarDriveZ)).EndInit();
			this.tabFocusSettings.ResumeLayout(false);
			this.groupBox5.ResumeLayout(false);
			this.groupBox6.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.tbarCruiseZ)).EndInit();
			this.tabFocusCal.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			// We will open up the OASIS library when the form loads.
			// Later, we will close it when the form closes.

			// Tell OASIS library we want to connect to the OASIS card
			Oasis.OI_SetHardwareMode( OasisLib.HW_MODES.OI_OASIS );
			
			// Open the library
			Oasis.OI_Open();

			// Dislay some basic info
			ShowInfo();

		}

		// Display basic info
		public void ShowInfo()
		{
			// NOTE: OASIS DLL uses char* so in C# we must us
			// StringBuilder for those calls
			StringBuilder szInfo = new StringBuilder(80);

			// Read the serial number of the card
			Oasis.OI_ReadSerialNum(0, szInfo, 80);
			lblInfo.Text = "Serial Num: " + szInfo.ToString();

			// Read the DLL version
			Oasis.OI_GetDriverVersion( szInfo, 80 );
			lblInfo.Text += "\n" + "DLL version: " + szInfo;

			// Read the DSP code version
			Oasis.OI_ReadPCBVersion( szInfo, 80 );
			lblInfo.Text += "\n" + "DSP revision: " + szInfo;
		}
		private void Form1_Closed(object sender, System.EventArgs e)
		{
			// Shut down our use of the card
			Oasis.OI_Close();
		}
		//
		// The timer that reads the position and displays it
		//
		private void tmrPos_Tick(object sender, System.EventArgs e)
		{
			double dX, dY, dZ;
			Oasis.OI_ReadXYZ( out dX, out dY, out dZ );
			lblPos.Text =	"X = " + dX.ToString("0.000") + "\n" + 
				"Y = " + dY.ToString("0.000") + "\n" + 
				"Z = " + dZ.ToString("0.000");
		}
		//
		// Stage Step tab handlers
		//
		private void btnYNeg_Click(object sender, System.EventArgs e)
		{
			double dStep = System.Convert.ToDouble(txtStepXY.Text);
			Oasis.OI_StepY( -dStep, chkWaitXY.Checked ? 1 : 0 );
		}
		private void btnYPos_Click(object sender, System.EventArgs e)
		{
			double dStep = System.Convert.ToDouble(txtStepXY.Text);
			Oasis.OI_StepY( dStep, chkWaitXY.Checked ? 1 : 0 );
		}
		private void btnXNeg_Click(object sender, System.EventArgs e)
		{
			double dStep = System.Convert.ToDouble(txtStepXY.Text);
			Oasis.OI_StepX( -dStep, chkWaitXY.Checked ? 1 : 0 );
		}
		private void btnXPos_Click(object sender, System.EventArgs e)
		{
			double dStep = System.Convert.ToDouble(txtStepXY.Text);
			Oasis.OI_StepX( dStep, chkWaitXY.Checked ? 1 : 0 );

		}
		//
		// Initialize the stage by moving to the negative and positive limits
		//
		private void btnInitXY_Click(object sender, System.EventArgs e)
		{
			// Show a dialog to confirm and warn about possible collision
			// with optics, e.g., lens and/or condensor
			MessageBoxButtons buttons = MessageBoxButtons.OKCancel;
			DialogResult result = 
				MessageBox.Show(
					this
					,"The stage will move to each corner.\n"
					+ "Please make sure the lens and condensor are clear."
					+ "\n\nWhen initializing, you can press the Esc key to halt."
					,"Initialize Stage?"
					,buttons
					,MessageBoxIcon.Question
					,MessageBoxDefaultButton.Button1
					,0);

			if( result == DialogResult.OK )
			{
				// Run the init of the stage.
				// This will travel to min limit swtiches in X and Y
				// then to max limits.
				// It will return the stage to the center and set the
				// min limit switches to be the origin XY=[0,0]
				Oasis.OI_InitializeXY();
			}
		}
		//
		// Stage Move tab handlers
		//
		private void btnReadXY_Click(object sender, System.EventArgs e)
		{
			double dX, dY;

			// read the current stage position
			Oasis.OI_ReadXY( out dX, out dY );

			txtMoveX.Text = dX.ToString();
			txtMoveY.Text = dY.ToString();
		}
		private void btnMoveXY_Click(object sender, System.EventArgs e)
		{
			double dX, dY;

			// make sure we don't have null stirngs
			if( txtMoveX.Text.Length==0 || txtMoveX.Text.Length==0)
				return;
			
			// convert to doubles
			dX = Convert.ToDouble(txtMoveX.Text);
			dY = Convert.ToDouble(txtMoveY.Text);

			// move the stage
			Oasis.OI_MoveToXY( dX, dY, chkWaitXY.Checked ? 1 : 0 );
		}
		//
		// Stage Drive tab handlers
		//
		// In this tab, the user can press down and hold a drive button to
		// move an axis neg or pos at constant speed.
		// When the button is released, a halt is issued to stop the stage.
		//
		private void btnHaltXY_Click(object sender, System.EventArgs e)
		{
			// force a halt of stage
			Oasis.OI_HaltXY();
		}
		private void btnDriveYNeg_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			int iSpeed;

			// get the desired speed from the TrackBar
			iSpeed = tbarDriveSpeed.Value;

			// start the Y axis moving in the neg direction at that speed
			Oasis.OI_DriveContinuousXY( 0, -iSpeed );
		}
		private void btnDriveYNeg_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Oasis.OI_HaltXY();
		}
		private void btnDriveXPos_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			int iSpeed;

			// get the desired speed from the TrackBar
			iSpeed = tbarDriveSpeed.Value;

			// start the Y axis moving in the neg direction at that speed
			Oasis.OI_DriveContinuousXY( iSpeed, 0 );
		}
		private void btnDriveXPos_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Oasis.OI_HaltXY();
		}
		private void btnDriveYPos_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			int iSpeed;

			// get the desired speed from the TrackBar
			iSpeed = tbarDriveSpeed.Value;

			// start the Y axis moving in the neg direction at that speed
			Oasis.OI_DriveContinuousXY( 0, iSpeed );
		}
		private void btnDriveYPos_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Oasis.OI_HaltXY();
		}
		private void btnDriveXNeg_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			int iSpeed;

			// get the desired speed from the TrackBar
			iSpeed = tbarDriveSpeed.Value;

			// start the Y axis moving in the neg direction at that speed
			Oasis.OI_DriveContinuousXY( -iSpeed, 0 );
		}
		private void btnDriveXNeg_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Oasis.OI_HaltXY();
		}
		//
		// Stage Settings tab handlers
		//
		private void tabStageSettings_Layout(object sender, System.Windows.Forms.LayoutEventArgs e)
		{
			int iX, iY;

			// read and display the current cruise speed
			Oasis.OI_GetCruiseXY( out iX, out iY );
			tbarCruiseX.Value = iX;
			tbarCruiseY.Value = iY;

			// read and display the current ramps
			Oasis.OI_GetRampXY( out iX, out iY );
			cboRampX.SelectedIndex = iX;
			cboRampY.SelectedIndex = iY;			
		}
		private void tbarCruiseX_ValueChanged(object sender, System.EventArgs e)
		{
			// Set the cruise on a change of value
			Oasis.OI_SetCruiseXY( tbarCruiseX.Value, tbarCruiseY.Value );
		}
		private void tbarCruiseY_ValueChanged(object sender, System.EventArgs e)
		{
			// Set the cruise on a change of value
			Oasis.OI_SetCruiseXY( tbarCruiseX.Value, tbarCruiseY.Value );
		}
		private void cboRampX_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			// Set the ramp on a change of combo list index
			Oasis.OI_SetRampXY( cboRampX.SelectedIndex, cboRampY.SelectedIndex );
		}
		private void cboRampY_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			// Set the ramp on a change of combo list index
			Oasis.OI_SetRampXY( cboRampX.SelectedIndex, cboRampY.SelectedIndex );		
		}
		//
		// Stage Cal tab handlers
		//
		private void txtPitchX_TextChanged(object sender, System.EventArgs e)
		{
			// if we get a change, enable the Set button
			btnSetPitch.Enabled = true;
		}
		private void txtPitchY_TextChanged(object sender, System.EventArgs e)
		{
			// if we get a change, enable the Set button
			btnSetPitch.Enabled = true;
		}
		private void btnSetPitch_Click(object sender, System.EventArgs e)
		{
			// Read the new pitch from the text boxes and set it
			double dX, dY;
			dX = Convert.ToDouble(txtPitchX.Text);
			dY = Convert.ToDouble(txtPitchY.Text);

			// Note that the SetPitchXY uses mm, not microns
			Oasis.OI_SetPitchXY( dX, dY );

			// Read it back for verification
			Oasis.OI_GetPitchXY( out dX, out dY );
			txtPitchX.Text = dX.ToString("#.00");
			txtPitchY.Text = dY.ToString("#.00");
		}
		private void tabStageCal_Layout(object sender, System.Windows.Forms.LayoutEventArgs e)
		{
			// Display the current settings for pitch
			double dX, dY;
			Oasis.OI_GetPitchXY( out dX, out dY );
			txtPitchX.Text = dX.ToString("#.00");
			txtPitchY.Text = dY.ToString("#.00");

			btnSetPitch.Enabled = false;
		}
		//
		// Focus Step tab handlers
		//
		private void btnZUp_Click(object sender, System.EventArgs e)
		{
			double dStep = Convert.ToDouble(txtStepZ.Text);
			Oasis.OI_StepZ( dStep, chkWaitZ.Checked ? 1 : 0 );
		}
		private void btnZDown_Click(object sender, System.EventArgs e)
		{
			double dStep = Convert.ToDouble(txtStepZ.Text);
			Oasis.OI_StepZ( -dStep, chkWaitZ.Checked ? 1 : 0 );
		}
		//
		// Focus Move tab handlers
		//
		private void btnReadZ_Click(object sender, System.EventArgs e)
		{
			// read and dipslay current focus position
			double dZ;
			Oasis.OI_ReadZ(out dZ);
			txtMoveZ.Text = dZ.ToString("0.000");
		}
		private void btnMoveZ_Click(object sender, System.EventArgs e)
		{
			double dZ;

			// make sure there's something in the text box
			if( txtMoveZ.Text.Length==0 )
				return;
			
			// convert it to double
			dZ = Convert.ToDouble(txtMoveZ.Text);

			// move the focus there
			Oasis.OI_MoveToZ( dZ, chkWaitZ.Checked ? 1 : 0 );
		}
		//
		// Focus Drive tab handlers
		//
		private void btnDriveZUp_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			// get the speed from the TrackBar
			int iSpeed;
			iSpeed = tbarDriveZ.Value;

			// Drive the focus as speed
			Oasis.OI_DriveContinuousZ( -iSpeed );
		}
		private void btnDriveZUp_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Oasis.OI_HaltZ();
		}
		private void btnDriveZDown_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			// get the speed from the TrackBar
			int iSpeed;
			iSpeed = tbarDriveZ.Value;

			// Drive the focus as speed
			Oasis.OI_DriveContinuousZ( iSpeed );
		}
		private void btnDriveZDown_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Oasis.OI_HaltZ();
		}
		private void btnHaltZ_Click(object sender, System.EventArgs e)
		{
			Oasis.OI_HaltZ();
		}
		//
		// Focus Settings tab handlers
		//
		private void tabFocusSettings_Layout(object sender, System.Windows.Forms.LayoutEventArgs e)
		{
			int iZ;
			Oasis.OI_GetCruiseZ( out iZ );
			tbarCruiseZ.Value = iZ;

			Oasis.OI_GetRampZ( out iZ );
			cboRampZ.SelectedIndex = iZ;
		}
		private void tbarCruiseZ_ValueChanged(object sender, System.EventArgs e)
		{
			Oasis.OI_SetCruiseZ( tbarCruiseZ.Value );
		}
		private void cboRampZ_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			Oasis.OI_SetRampZ( cboRampZ.SelectedIndex );
		}
		private void btnInitZ_Click(object sender, System.EventArgs e)
		{
			double dMax, dMin;

			// Initialize Z will:
			// 1) set the current position to Z=0
			// 2) set the user limits to the range as specified

			// get the range above and below the current position
			dMax = Convert.ToDouble( txtRangeZUp.Text );
			dMin = Convert.ToDouble( txtRangeZDown.Text );

			// call the init
			Oasis.OI_InitializeZ( dMax, dMin );
		}

		private void tabFocusCal_Layout(object sender, System.Windows.Forms.LayoutEventArgs e)
		{
			double dMax, dMin;
			double dPitch;

			// read the range of focus travel between user limits
			Oasis.OI_ReadRangeZ( out dMin, out dMax );
			
			// display them
			txtRangeZUp.Text = dMax.ToString("0.000");
			txtRangeZDown.Text = dMin.ToString("0.000");
			
			// read the current pitch, in mm
			// (for focus, pitch is the Z travel per rev)
			Oasis.OI_GetPitchZ( out dPitch );
			txtPitchZ.Text = dPitch.ToString("0.000");
		}
	}
}
