Option Strict Off
Option Explicit On
Module oasis4i
	
	'///////////////// OI DLL CONSTANTS /////////////////
	
	'///////////////////////////////////////////
	'// Return Codes
	'///////////////////////////////////////////
	Public Const OI_OK As Short = 0
	Public Const OI_FAILED As Short = 1
	Public Const OI_ABORT As Short = 2
	Public Const OI_NOHARDWARE As Short = 4
	Public Const OI_TIMEOUT As Short = 8
	Public Const OI_INVALIDARG As Short = 16
	Public Const OI_HARDWAREBUSY As Short = 32
	Public Const OI_ACCESSDENIED As Short = 64
	Public Const OI_NOTSUPPORTED As Short = 128
	Public Const OI_ILLEGALAXIS As Short = 256
	Public Const OI_INVALIDCONFIG As Short = 512
	Public Const OI_MAXMOVEFAIL As Short = 1024
	
	'///////////////////////////////////////////
	'// Axes IDs
	'///////////////////////////////////////////
	Public Const OI_XAXIS As Short = 1
	Public Const OI_YAXIS As Short = 2
	Public Const OI_ZAXIS As Short = 3
	Public Const OI_FAXIS As Short = 4
	Public Const OI_TAXIS As Short = 5
	
	'///////////////////////////////////////////
	'// Axis Types (reserved)
	'///////////////////////////////////////////
	Public Const OI_TYPE_NOT_FITTED As Short = 0
	Public Const OI_TYPE_STEPPER As Short = 1
	Public Const OI_TYPE_DC As Short = 2
	Public Const OI_TYPE_SIMULATED As Short = 3
	
	'///////////////////////////////////////////
	'// Init Methods (reserved)
	'///////////////////////////////////////////
	Public Const OI_INITBY_SWITCH As Short = 0
	Public Const OI_INITBY_MANUAL As Short = 1
	
	'///////////////////////////////////////////
	'// Hardware Modes
	'///////////////////////////////////////////
	Public Const OI_SIM As Short = 0
	Public Const OI_OASIS As Short = 1
	Public Const OI_LEICA_DM As Short = 10
	Public Const OI_LEICA_DM2 As Short = 11
	Public Const OI_LEICA_MZ As Short = 12
	Public Const OI_OLYMPUS_BX As Short = 20
	Public Const OI_OLYMPUS_IX As Short = 21
	Public Const OI_NAVITAR As Short = 50
	Public Const OI_OPTEM As Short = 51
	
	'///////////////////////////////////////////
	'// Status Codes
	'///////////////////////////////////////////
	Public Const S_LIMIT_PHY_NEG As Short = &H1s
	Public Const S_LIMIT_USR_NEG As Short = &H2s
	Public Const S_LIMIT_PHY_POS As Short = &H8s
	Public Const S_LIMIT_USR_POS As Short = &H4s
	Public Const S_LIMIT_USR_NEG_SET As Short = &H10s
	Public Const S_LIMIT_USR_POS_SET As Short = &H20s
	Public Const S_INITIALIZED As Short = &H40s
	Public Const S_DIRECTION As Short = &H80s
	Public Const S_MOVING As Short = &H100s
	Public Const S_MOTOR_DETECTED As Short = &H8000s
	
	'///////////////////////////////////////////
	'// PCB STATUS BITS
	'/*
	'Bit meaning
	'----------------
	'31  Reserved
	'30  Reserved
	'29  Reserved
	'28  Reserved
	'27  Reserved
	'26  Reserved
	'25  Reserved
	'24  Reserved
	'23  Reserved
	'22  Reserved
	'21  Reserved
	'20  Reserved
	'19  Flash_user_OK       ( 1 = Flash user area checksum OK )
	'18  Flash_OI_OK         ( 1 = Flash OI area checksum OK )
	'17  Reserved
	'16  Joystick_detect     ( 1 = Joystick unit fitted )
	'15  Reserved
	'14  Trackball_detect        ( 1 = Serial device is Kensington Trackball 5)
	'13  Mouse_detect            ( 1 = Serial device is standard 2-button mouse)
	'12  Serial_Device_detect        ( 1 = Serial device detected on RS232_0)
	'11  Camera_type         ( 1 = Colour, 0 = Mono )
	'10  Camera_frequency        ( 1 = 50 Hz, 0 = 60 Hz )
	'9   Camera_channel      ( 1 = Channel 3, 0 = channel 0 (default))
	'8   Camera_detect       ( 1 = Camera input detected )
	'7   Video_Encoder_OK        ( 1 = Encoder configured OK )
	'6   Autofocus_Module_type_1 ( 2 bit code indicating module type )
	'5   Autofocus_Module_type_0 ( 2 bit code indicating module type )
	'4   Autofocus_Module_fitted ( 1 = Module Detected )
	'3   ADC_Analogue_input_X    ( 1 = ADC zero (correct) at switch on )
	'2   ADC_Analogue_input_Y    ( 1 = ADC zero (correct) at switch on )
	'1   PCB_Temperature     ( 1 = Temperature too high )
	'0   Motor_volts_OK      ( 1 = Motor supply >= 10V i.e. OK )
	'*/
	'///////////////////////////////////////////
	Public Const S_PCB_MOTOR_VOLTS_OK As Short = &H1s
	Public Const S_PCB_TEMP_OK As Short = &H2s
	Public Const S_PCB_ADC_YIN_OK As Short = &H4s
	Public Const S_PCB_ADC_XIN_OK As Short = &H8s
	Public Const S_PCB_AF_FITTED As Short = &H10s
	Public Const S_PCB_AF_TYPE0 As Short = &H20s
	Public Const S_PCB_AF_TYPE1 As Short = &H40s
	Public Const S_PCB_VIDEO_ENCODER_OK As Short = &H80s
	Public Const S_PCB_CAMERA_DETECTED As Short = &H100s
	Public Const S_PCB_CAMERA_CHANNEL As Short = &H200s
	Public Const S_PCB_CAMERA_FREQ As Short = &H400s
	Public Const S_PCB_CAMERA_TYPE As Short = &H800s
	Public Const S_PCB_SERIAL_DEV_DETECTED As Short = &H1000s
	Public Const S_PCB_MOUSE_DETECTED As Short = &H2000s
	Public Const S_PCB_TRACKBALL_FITTED As Short = &H4000s
	'//      reserved                    &H8000
	Public Const S_PCB_JOYSTICK_FITTED As Integer = &H10000
	'//      reserved                    &H20000
	Public Const S_PCB_FLASH_OI_OK As Integer = &H40000
	Public Const S_PCB_FLASH_USER_OK As Integer = &H80000
	
	
	'///////////////////////////////////////////
	'// Range constants
	'///////////////////////////////////////////
	Public Const OI_CRUISE_MIN As Short = 0
	Public Const OI_CRUISE_MAX As Short = 511
	Public Const OI_RAMP_MIN As Short = 0
	Public Const OI_RAMP_MAX As Short = 3
	Public Const OI_DRIVE_SPEED_MIN As Short = -4096
	Public Const OI_DRIVE_SPEED_MAX As Short = 4096
	
	
	'////////////////////////////////////////////////////////
	'// Filter initialization methods
	'////////////////////////////////////////////////////////
	Public Const OI_FILTER_INIT_HOME As Short = 0
	Public Const OI_FILTER_INIT_LIMITS As Short = 1
	Public Const OI_FILTER_INIT_USER As Short = 2
	
	'////////////////////////////////////////////////////////
	'// OI-SC4 Shutter Controller masks
	'////////////////////////////////////////////////////////
	Public Const SHUTTER1 As Short = 1
	Public Const SHUTTER2 As Short = 2
	Public Const SHUTTER3 As Short = 4
	Public Const SHUTTER4 As Short = 8
	
	'///////////////////////////////////////////////////////////////////////
	'// Hardware defs
	Declare Function OI_Open Lib "oasis4i.dll" () As Integer
	Declare Function OI_Close Lib "oasis4i.dll" () As Integer
	Declare Function OI_GetDriverOpen Lib "oasis4i" (ByRef bOpen As Integer) As Integer
	
	Declare Function OI_SetHardwareMode Lib "oasis4i" (ByVal nMode As Integer) As Integer
	Declare Function OI_GetHardwareMode Lib "oasis4i" (ByRef pnMode As Integer) As Integer
	
	Declare Function OI_SetAutoFocusHWMode Lib "oasis4i" (ByVal nMode As Integer) As Integer
	Declare Function OI_GetAutoFocusHWMode Lib "oasis4i" (ByRef pnMode As Integer) As Integer
	
	Declare Function OI_GetAFFitted Lib "oasis4i" (ByRef pbFitted As Integer) As Integer
	Declare Function OI_SetAFFitted Lib "oasis4i" (ByVal bFitted As Integer) As Integer
	
	Declare Function OI_ReadPCBStatus Lib "oasis4i" (ByRef lpdwHWState As Integer) As Integer
	Declare Function OI_ReadPCBTemperature Lib "oasis4i" (ByRef dTempC As Double) As Integer
	Declare Function OI_ReadADCValues Lib "oasis4i" (ByRef pwValArray As Short) As Integer
	
	Declare Function OI_CountCards Lib "oasis4i" (ByRef pnFound As Integer) As Integer
	
	'///////////////////////////////////////////////////////////////////////
	'// Version functions
	Declare Function OI_GetDriverVersion Lib "oasis4i" (ByVal pVersion As String, ByVal nStringLen As Integer) As Integer
	Declare Function OI_ReadPCBID Lib "oasis4i" (ByVal pIDBuffer As String, ByVal nStringLen As Integer) As Integer
	Declare Function OI_ReadPCBVersion Lib "oasis4i" (ByVal pVersion As String, ByVal nStringLen As Integer) As Integer
	
	'///////////////////////////////////////////////////////////////////////
	'// General, Single Axis
	Declare Function OI_GetTotalAxisCount Lib "oasis4i" (ByRef pnAxisCount As Integer) As Integer
	Declare Function OI_GetAxisEnabled Lib "oasis4i" (ByVal AxisID As Integer, ByRef pbEnabled As Short) As Integer
	Declare Function OI_MoveAxis Lib "oasis4i" (ByVal AxisID As Integer, ByVal dValue As Double, ByVal nWait As Integer) As Integer
	Declare Function OI_ReadAxis Lib "oasis4i" (ByVal AxisID As Integer, ByRef pdVdalue As Double) As Integer
	Declare Function OI_GetAxisRange Lib "oasis4i" (ByVal AxisID As Integer, ByRef pdMin As Double, ByRef pdMax As Double) As Integer
	Declare Function OI_SetAxisStepSize Lib "oasis4i" (ByVal AxisID As Integer, ByVal dStepSize As Double) As Integer
	Declare Function OI_GetAxisStepSize Lib "oasis4i" (ByVal AxisID As Integer, ByRef pdStepSize As Double) As Integer
	Declare Function OI_SetAxisBacklash Lib "oasis4i" (ByVal AxisID As Integer, ByVal bEnabled As Short) As Integer
	Declare Function OI_GetAxisBacklash Lib "oasis4i" (ByVal AxisID As Integer, ByRef pbEnabled As Short) As Integer
	Declare Function OI_GetAxisCruise Lib "oasis4i" (ByVal AxisID As Integer, ByRef pnCruise As Integer) As Integer
	Declare Function OI_SetAxisCruise Lib "oasis4i" (ByVal AxisID As Integer, ByVal nCruise As Integer) As Integer
	Declare Function OI_GetAxisSense Lib "oasis4i" (ByVal AxisID As Integer, ByRef pnSense As Integer) As Integer
	Declare Function OI_SetAxisSense Lib "oasis4i" (ByVal AxisID As Integer, ByVal nSense As Integer) As Integer
	Declare Function OI_GetAxisRamp Lib "oasis4i" (ByVal AxisID As Integer, ByRef pnRamp As Integer) As Integer
	Declare Function OI_SetAxisRamp Lib "oasis4i" (ByVal AxisID As Integer, ByVal nRamp As Integer) As Integer
	Declare Function OI_DriveAxisContinuous Lib "oasis4i" (ByVal AxisID As Integer, ByVal nSpeed As Integer) As Integer
	Declare Function OI_StepAxis Lib "oasis4i" (ByVal AxisID As Integer, ByVal dValue As Double, ByVal nWait As Integer) As Integer
	Declare Function OI_SetAxisInitMethod Lib "oasis4i" (ByVal AxisID As Integer, ByVal nMethod As Integer) As Integer
	Declare Function OI_GetAxisInitMethod Lib "oasis4i" (ByVal AxisID As Integer, ByRef pnMethod As Integer) As Integer
	Declare Function OI_ReadAxisAtLimit Lib "oasis4i" (ByVal AxisID As Integer, ByRef pbAtNegLimit As Short, ByRef pbAtPosLimit As Short) As Integer
	Declare Function OI_ReadAxisMoving Lib "oasis4i" (ByVal AxisID As Integer, ByRef pbIsMoving As Short) As Integer
	Declare Function OI_ReadAxisStatus Lib "oasis4i" (ByVal AxisID As Integer, ByRef lpwStatus As Short) As Integer
	Declare Function OI_SetAxisToDefaults Lib "oasis4i" (ByVal AxisID As Integer) As Integer
	Declare Function OI_ReadAxisRampValue Lib "oasis4i" (ByVal AxisID As Integer, ByVal wIndex As Short, ByRef lpwInterval As Short, ByRef lpwStepSize As Short) As Integer
	Declare Function OI_HaltAxis Lib "oasis4i" (ByVal AxisID As Integer) As Integer
	Declare Function OI_GetAxisMaxMove Lib "oasis4i" (ByVal AxisID As Integer, ByRef lpdwValue As Integer) As Integer
	Declare Function OI_GetAxisStepsPerRev Lib "oasis4i" (ByVal AxisID As Integer, ByRef lpdwStepsPerRev As Integer) As Integer
	Declare Function OI_MoveAxisAbs Lib "oasis4i" (ByVal AxisID As Integer, ByVal lPos As Integer, ByVal nWait As Integer) As Integer
	Declare Function OI_StepAxisAbs Lib "oasis4i" (ByVal AxisID As Integer, ByVal lSteps As Integer, ByVal nWait As Integer) As Integer
	Declare Function OI_ReadAxisAbs Lib "oasis4i" (ByVal AxisID As Integer, ByRef plPos As Integer) As Integer
	Declare Function OI_GetAxisRangeAbs Lib "oasis4i" (ByVal AxisID As Integer, ByRef plMin As Integer, ByRef plMax As Integer) As Integer
	Declare Function OI_WaitForAxisStopped Lib "oasis4i" (ByVal AxisID As Integer) As Integer
	
	
	'///////////////////////////////////////////////////////////////////////
	'// Full axes
	Declare Function OI_SetPositionXYZ Lib "oasis4i" (ByVal xpos As Double, ByVal ypos As Double, ByVal zpos As Double) As Integer
	Declare Function OI_MoveToXYZ Lib "oasis4i" (ByVal xpos As Double, ByVal ypos As Double, ByVal zpos As Double, ByVal nWait As Integer) As Integer
	Declare Function OI_MoveToXYZ_Auto Lib "oasis4i" (ByVal xpos As Double, ByVal ypos As Double, ByVal zpos As Double, ByVal nWait As Integer) As Integer
	Declare Function OI_ReadXYZ Lib "oasis4i" (ByRef xpos As Double, ByRef ypos As Double, ByRef zpos As Double) As Integer
	Declare Function OI_WaitForStoppedXYZ Lib "oasis4i" (ByVal xstop As Integer, ByVal ystop As Integer, ByVal zstop As Integer) As Integer
	Declare Function OI_DriveContinuousXYZ Lib "oasis4i" (ByVal nXSpeed As Integer, ByVal nYSpeed As Integer, ByVal nZSpeed As Integer) As Integer
	
	'///////////////////////////////////////////////////////////////////////
	'// XY Stage conveniences: X and Y Axes combined
	Declare Function OI_InitializeXY Lib "oasis4i" () As Integer
	Declare Function OI_SetPositionXY Lib "oasis4i" (ByVal xpos As Double, ByVal ypos As Double) As Integer
	Declare Function OI_SetOriginXY Lib "oasis4i" () As Integer
	Declare Function OI_ReadXY Lib "oasis4i" (ByRef xpos As Double, ByRef ypos As Double) As Integer
	Declare Function OI_MoveToXY Lib "oasis4i" (ByVal xpos As Double, ByVal ypos As Double, ByVal nWait As Integer) As Integer
	Declare Function OI_MoveToXY_Auto Lib "oasis4i" (ByVal xpos As Double, ByVal ypos As Double, ByVal nWait As Integer) As Integer
	Declare Function OI_StepXY Lib "oasis4i" (ByVal dXDistance As Double, ByVal dYDistance As Double, ByVal nWait As Integer) As Integer
	Declare Function OI_StepX Lib "oasis4i" (ByVal dXDistance As Double, ByVal nWait As Integer) As Integer
	Declare Function OI_StepY Lib "oasis4i" (ByVal dYDistance As Double, ByVal nWait As Integer) As Integer
	Declare Function OI_ReadStatusXY Lib "oasis4i" (ByRef lpwXStatus As Short, ByRef lpwYStatus As Short) As Integer
	Declare Function OI_GetPitchXY Lib "oasis4i" (ByRef pdXPitch As Double, ByRef pdYPitch As Double) As Integer
	Declare Function OI_SetPitchXY Lib "oasis4i" (ByVal dXPitch As Double, ByVal dYPitch As Double) As Integer
	Declare Function OI_SetRampXY Lib "oasis4i" (ByVal nXRamp As Integer, ByVal nYRamp As Integer) As Integer
	Declare Function OI_GetRampXY Lib "oasis4i" (ByRef pnXRamp As Integer, ByRef pnYRamp As Integer) As Integer
	Declare Function OI_SetCruiseXY Lib "oasis4i" (ByVal nXCruise As Integer, ByVal nYCruise As Integer) As Integer
	Declare Function OI_GetCruiseXY Lib "oasis4i" (ByRef pnXCruise As Integer, ByRef pnYCruise As Integer) As Integer
	Declare Function OI_SetDriveSenseXY Lib "oasis4i" (ByVal nXDir As Integer, ByVal nYDir As Integer) As Integer
	Declare Function OI_GetDriveSenseXY Lib "oasis4i" (ByRef pnXDir As Integer, ByRef pnYDir As Integer) As Integer
	Declare Function OI_DriveContinuousXY Lib "oasis4i" (ByVal nXSpeed As Integer, ByVal nYSpeed As Integer) As Integer
	Declare Function OI_HaltXY Lib "oasis4i" () As Integer
	Declare Function OI_SetUserLimitsXY Lib "oasis4i" (ByVal dXMin As Double, ByVal dXMax As Double, ByVal dYMin As Double, ByVal dYMax As Double) As Integer
	Declare Function OI_GetUserLimitsXY Lib "oasis4i" (ByRef pdXMin As Double, ByRef pdXMax As Double, ByRef pdYMin As Double, ByRef pdYMax As Double) As Integer
	Declare Function OI_ReadLimitAlarmsXY Lib "oasis4i" (ByRef XNeg As Integer, ByRef xpos As Integer, ByRef YNeg As Integer, ByRef ypos As Integer) As Integer
	
	'///////////////////////////////////////////////////////////////////////
	'// Z Axis
	Declare Function OI_InitializeZ Lib "oasis4i.dll" (ByVal ZRangeAbove As Double, ByVal ZRangeBelow As Double) As Integer
	Declare Function OI_SetPositionZ Lib "oasis4i.dll" (ByVal zpos As Double) As Integer
	Declare Function OI_ReadZ Lib "oasis4i.dll" (ByRef zpos As Double) As Integer
	Declare Function OI_MoveToZ Lib "oasis4i.dll" (ByVal zpos As Double, ByVal nWait As Integer) As Integer
	Declare Function OI_StepZ Lib "oasis4i.dll" (ByVal ZDistance As Double, ByVal nWait As Integer) As Integer
	Declare Function OI_ReadStatusZ Lib "oasis4i" (ByRef lpwStatus As Short) As Integer
	Declare Function OI_SetRampZ Lib "oasis4i" (ByVal nZRamp As Integer) As Integer
	Declare Function OI_GetRampZ Lib "oasis4i" (ByRef pnZRamp As Integer) As Integer
	Declare Function OI_SetCruiseZ Lib "oasis4i" (ByVal nZCruise As Integer) As Integer
	Declare Function OI_GetCruiseZ Lib "oasis4i" (ByRef pnZCruise As Integer) As Integer
	Declare Function OI_SetDriveSenseZ Lib "oasis4i" (ByVal nZDir As Integer) As Integer
	Declare Function OI_GetDriveSenseZ Lib "oasis4i" (ByRef pnZDir As Integer) As Integer
	Declare Function OI_DriveContinuousZ Lib "oasis4i" (ByVal nSpeed As Integer) As Integer
	Declare Function OI_HaltZ Lib "oasis4i" () As Integer
	Declare Function OI_ReadRangeZ Lib "oasis4i" (ByRef pZMin As Double, ByRef pZMax As Double) As Integer
	Declare Function OI_SetUserLimitsZ Lib "oasis4i" (ByVal dZMin As Double, ByVal dZMax As Double) As Integer
	Declare Function OI_GetUserLimitsZ Lib "oasis4i" (ByRef pdZMin As Double, ByRef pdZMax As Double) As Integer
	Declare Function OI_SetFocusJoystick Lib "oasis4i" (ByVal nLeft As Integer, ByVal nRight As Integer) As Integer
	Declare Function OI_SetOriginZ Lib "oasis4i" () As Integer
	
	'///////////////////////////////////////////////////////////////////////
	'// F Axis
	Declare Function OI_InitializeF Lib "oasis4i" () As Integer
	Declare Function OI_InitializeFRange Lib "oasis4i" (ByVal FNegLimit As Double, ByVal FPosLimit As Double) As Integer
	Declare Function OI_SetPositionF Lib "oasis4i" (ByVal dFPos As Double) As Integer
	Declare Function OI_ReadF Lib "oasis4i" (ByRef pF As Double) As Integer
	Declare Function OI_MoveToF Lib "oasis4i" (ByVal f As Double, ByVal nWait As Integer) As Integer
	Declare Function OI_StepF Lib "oasis4i" (ByVal FDistance As Double, ByVal nWait As Integer) As Integer
	Declare Function OI_ReadStatusF Lib "oasis4i" (ByRef lpwStatus As Short) As Integer
	Declare Function OI_SetRampF Lib "oasis4i" (ByVal nFRamp As Integer) As Integer
	Declare Function OI_GetRampF Lib "oasis4i" (ByRef pnFRamp As Integer) As Integer
	Declare Function OI_SetCruiseF Lib "oasis4i" (ByVal nFCruise As Integer) As Integer
	Declare Function OI_GetCruiseF Lib "oasis4i" (ByRef pnFCruise As Integer) As Integer
	Declare Function OI_SetDriveSenseF Lib "oasis4i" (ByVal nFDir As Integer) As Integer
	Declare Function OI_GetDriveSenseF Lib "oasis4i" (ByRef pnFDir As Integer) As Integer
	Declare Function OI_HaltF Lib "oasis4i" () As Integer
	Declare Function OI_ReadRangeF Lib "oasis4i" (ByRef pFMin As Double, ByRef pFMax As Double) As Integer
	Declare Function OI_GetStepSizeF Lib "oasis4i" (ByRef dStepSize As Double) As Integer
	Declare Function OI_SetStepSizeF Lib "oasis4i" (ByVal dStepSize As Double) As Integer
	Declare Function OI_WaitForStoppedF Lib "oasis4i" () As Integer
	Declare Function OI_SetUserLimitsF Lib "oasis4i" (ByVal pFMin As Double, ByVal pFMax As Double) As Integer
	Declare Function OI_GetUserLimitsF Lib "oasis4i" (ByRef pFMin As Double, ByRef pFMax As Double) As Integer
	Declare Function OI_SetOriginF Lib "oasis4i" () As Integer
	
	'///////////////////////////////////////////////////////////////////////
	'// T Axis
	Declare Function OI_InitializeT Lib "oasis4i" () As Integer
	Declare Function OI_InitializeTRange Lib "oasis4i" (ByVal dNegLimit As Double, ByVal dPosLimit As Double) As Integer
	Declare Function OI_SetPositionT Lib "oasis4i" (ByVal dPos As Double) As Integer
	Declare Function OI_ReadT Lib "oasis4i" (ByRef pdPos As Double) As Integer
	Declare Function OI_MoveToT Lib "oasis4i" (ByVal dPos As Double, ByVal nWait As Integer) As Integer
	Declare Function OI_StepT Lib "oasis4i" (ByVal dDistance As Double, ByVal nWait As Integer) As Integer
	Declare Function OI_ReadStatusT Lib "oasis4i" (ByRef lpwStatus As Short) As Integer
	Declare Function OI_SetRampT Lib "oasis4i" (ByVal nRamp As Integer) As Integer
	Declare Function OI_GetRampT Lib "oasis4i" (ByRef pnRamp As Integer) As Integer
	Declare Function OI_SetCruiseT Lib "oasis4i" (ByVal nCruise As Integer) As Integer
	Declare Function OI_GetCruiseT Lib "oasis4i" (ByRef pnCruise As Integer) As Integer
	Declare Function OI_SetDriveSenseT Lib "oasis4i" (ByVal nDir As Integer) As Integer
	Declare Function OI_GetDriveSenseT Lib "oasis4i" (ByRef pnDir As Integer) As Integer
	Declare Function OI_HaltT Lib "oasis4i" () As Integer
	Declare Function OI_ReadRangeT Lib "oasis4i" (ByRef pdMin As Double, ByRef pdMax As Double) As Integer
	Declare Function OI_GetStepSizeT Lib "oasis4i" (ByRef dStepSize As Double) As Integer
	Declare Function OI_SetStepSizeT Lib "oasis4i" (ByVal dStepSize As Double) As Integer
	Declare Function OI_WaitForStoppedT Lib "oasis4i" () As Integer
	Declare Function OI_SetUserLimitsT Lib "oasis4i" (ByVal dMin As Double, ByVal dMax As Double) As Integer
	Declare Function OI_GetUserLimitsT Lib "oasis4i" (ByRef pdMin As Double, ByRef pdMax As Double) As Integer
	Declare Function OI_SetOriginT Lib "oasis4i" () As Integer
	Declare Function OI_ReadLimitAlarmsT Lib "oasis4i" (ByRef pnNeg As Integer, ByRef pnPos As Integer) As Integer
	Declare Function OI_SetPitchT Lib "oasis4i" (ByVal dPitchMM As Double) As Integer
	Declare Function OI_GetPitchT Lib "oasis4i" (ByRef pdPitchMM As Double) As Integer
	Declare Function OI_ReadMaxMoveT Lib "oasis4i" (ByRef lpdwSteps As Integer, ByRef lpwDecel As Short) As Integer
	Declare Function OI_GetSpeedT Lib "oasis4i" (ByRef pdSpeed As Double) As Integer
	Declare Function OI_SelectSpeedT Lib "oasis4i" (ByVal dFmmPerSec As Double, ByVal nFlags As Integer) As Integer
	Declare Function OI_LookupSpeedT Lib "oasis4i" (ByVal nCruise As Integer, ByRef pdSpeed As Double) As Integer
	Declare Function OI_ClearUserLimitsT Lib "oasis4i" () As Integer
	
	'///////////////////////////////////////////////////////////////////////
	'// Autofocus
	Declare Function OI_SetAutoFocus Lib "oasis4i" (ByVal dRange As Double, ByVal Speed As Integer, ByVal Tolerance As Integer) As Integer
	Declare Function OI_GetAutoFocus Lib "oasis4i" (ByRef pdRange As Double, ByRef Speed As Integer, ByRef pnTolerance As Integer) As Integer
	Declare Function OI_AutoFocus Lib "oasis4i" () As Integer
	Declare Function OI_AutoFocusEx Lib "oasis4i" (ByVal dRange As Double, ByVal Speed As Integer, ByVal Tolerance As Integer) As Integer
	Declare Function OI_AutoFocus_Step Lib "oasis4i" (ByVal dRange As Double, ByVal Speed As Integer, ByVal Tolerance As Integer, ByVal dStepSize As Double) As Integer
	Declare Function OI_SetAutoFocusThreshold Lib "oasis4i" (ByVal wThresh As Short) As Integer
	Declare Function OI_GetAutoFocusThreshold Lib "oasis4i" (ByRef lpwThresh As Short) As Integer
	Declare Function OI_ReadFocusScore Lib "oasis4i" (ByRef Score As Double) As Integer
	Declare Function OI_ReadFocusScoreEx Lib "oasis4i" (ByRef Score As Double, ByRef zpos As Double) As Integer
	Declare Function OI_ReadFocusProfile Lib "oasis4i" (ByRef pdArray As Double, ByRef pdZPos As Double, ByVal nSize As Integer, ByRef pnSamples As Integer) As Integer
	Declare Function OI_RequestAutoFocusStatus Lib "oasis4i" (ByRef Finished As Short, ByRef Success As Short, ByRef NumSamples As Short) As Integer
	Declare Function OI_RequestFocusStatus Lib "oasis4i" (ByRef Status As Short) As Integer
	Declare Function OI_WaitForAutoFocus Lib "oasis4i" () As Integer
	
	'///////////////////////////////////////////////////////////////////////
	'// Video
	Declare Function OI_SetVideoSettings Lib "oasis4i" (ByVal nEvenPhase As Integer, ByVal nEvenThreshold As Integer, ByVal nOddPhase As Integer, ByVal nOddThreshold As Integer) As Integer
	Declare Function OI_GetVideoSettings Lib "oasis4i" (ByRef nEvenPhase As Integer, ByRef nEvenThreshold As Integer, ByRef nOddPhase As Integer, ByRef nOddThreshold As Integer) As Integer
	Declare Function OI_ReadVideoData Lib "oasis4i" (ByRef nStatus As Short, ByRef pdwArea As Integer, ByRef pwMaxChord As Short, ByRef pwMaxGradient As Short) As Integer
	Declare Function OI_ReadVideoResults Lib "oasis4i" (ByVal nMode As Integer, ByRef pdwArea As Integer, ByRef pwMaxChord As Short) As Integer
	Declare Function OI_ReadVideoResultsEx Lib "oasis4i" (ByVal nMode As Object, ByRef pdwArea As Integer, ByRef pwMaxChord As Short, ByRef pwMaxGradient As Short) As Integer
	Declare Function OI_ReadVideoResultsXYZF Lib "oasis4i" (ByVal nMode As Integer, ByRef pdResults As Double, ByRef pdPositions As Double) As Integer
	Declare Function OI_ReadVideoResultsZ Lib "oasis4i" (ByVal nMode As Integer, ByRef pdResults As Double, ByRef pdZPos As Double) As Integer
	Declare Function OI_ReadVideoResultsXY Lib "oasis4i" (ByVal nMode As Integer, ByRef pdResults As Double, ByRef pdXPos As Double, ByRef pdYPos As Double) As Integer
	Declare Function OI_IsVideoDetected Lib "oasis4i" (ByRef bFound As Integer) As Integer
	Declare Function OI_SetVideoWindow Lib "oasis4i" (ByVal nXStart As Integer, ByVal nXStop As Integer, ByVal nYStart As Integer, ByVal nYStop As Integer) As Integer
	Declare Function OI_GetVideoWindow Lib "oasis4i" (ByRef nXStart As Integer, ByRef nXStop As Integer, ByRef nYStart As Integer, ByRef nYStop As Integer) As Integer
	
	'///////////////////////////////////////////////////////////////////////
	'// General stops
	Declare Function OI_HaltAllAxes Lib "oasis4i" () As Integer
	Declare Function OI_EmergencyStopAll Lib "oasis4i" () As Integer
	
	'///////////////////////////////////////////////////////////////////////
	'// Timeouts
	Declare Function OI_SetVideoTimeout Lib "oasis4i" (ByVal dwMSecs As Integer) As Integer
	Declare Function OI_GetVideoTimeout Lib "oasis4i" (ByRef lpdwMSecs As Integer) As Integer
	Declare Function OI_SetAutoFocusTimeout Lib "oasis4i" (ByVal dwMSecs As Integer) As Integer
	Declare Function OI_GetAutoFocusTimeout Lib "oasis4i" (ByRef lpdwMSecs As Integer) As Integer
	Declare Function OI_SetMoveTimeout Lib "oasis4i" (ByVal dwMSecs As Integer) As Integer
	Declare Function OI_GetMoveTimeout Lib "oasis4i" (ByRef lpdwMSecs As Integer) As Integer
	
	'///////////////////////////////////////////////////////////////////////
	'// File I/O
	Declare Function OI_SaveSettings Lib "oasis4i" (ByVal sFile As String) As Integer
	Declare Function OI_LoadSettings Lib "oasis4i" (ByVal sFile As String) As Integer
	Declare Function OI_SavePositions Lib "oasis4i" (ByVal sFile As String) As Integer
	Declare Function OI_LoadPositions Lib "oasis4i" (ByVal sFile As String) As Integer
	
	'///////////////////////////////////////////////////////////////////////
	'// Filter Changer
	Declare Function OI_SetFilterCount Lib "oasis4i" (ByVal nFilters As Integer) As Integer
	Declare Function OI_GetFilterCount Lib "oasis4i" (ByRef pnFilters As Integer) As Integer
	Declare Function OI_DeleteFilter Lib "oasis4i" (ByVal nPosition As Integer) As Integer
	Declare Function OI_MoveToFilter Lib "oasis4i" (ByVal nPosition As Integer, ByVal nWait As Integer) As Integer
	Declare Function OI_GetFilterPosition Lib "oasis4i" (ByRef pnPosition As Integer) As Integer
	Declare Function OI_InitFilterChanger Lib "oasis4i" (ByVal nMethod As Integer, ByVal dUnitsPerRev As Double) As Integer
	Declare Function OI_SetFilterHomeOffset Lib "oasis4i" (ByVal dOffset As Double) As Integer
	Declare Function OI_GetFilterHomeOffset Lib "oasis4i" (ByRef pdOffset As Double) As Integer
	Declare Function OI_WaitForStoppedFilter Lib "oasis4i" () As Integer
	Declare Function OI_SetFilterName Lib "oasis4i" (ByVal nPosition As Integer, ByVal szBuffer As String) As Integer
	Declare Function OI_GetFilterName Lib "oasis4i" (ByVal nPosition As Integer, ByVal szBuffer As String, ByVal nBufferLen As Integer) As Integer
	Declare Function OI_SetFilterDescription Lib "oasis4i" (ByVal nPosition As Integer, ByVal szBuffer As String) As Integer
	Declare Function OI_GetFilterDescription Lib "oasis4i" (ByVal nPosition As Integer, ByVal szBuffer As String, ByVal nBufferLen As Integer) As Integer
	Declare Function OI_ReadFilterHomeInfo Lib "oasis4i" (ByRef lpbHomeFound As Short, ByRef pdHomeLeft As Double, ByRef pdHomeRight As Double) As Integer
	Declare Function OI_ReadFilterChangerInfo Lib "oasis4i" (ByRef pdUnitsPerRev As Double, ByRef pdFilterSpacing As Double) As Integer
	Declare Function OI_SetFilterOffset Lib "oasis4i" (ByVal nPosition As Integer, ByVal dOffset As Double) As Integer
	Declare Function OI_GetFilterOffset Lib "oasis4i" (ByVal nPosition As Integer, ByRef pdOffset As Double) As Integer
	Declare Function OI_SetFilterLocation Lib "oasis4i" (ByVal nPosition As Integer) As Integer
	Declare Function OI_ClearFilterHomeInfo Lib "oasis4i" (ByRef void As Object) As Integer
	
	Declare Function OI_SelectFilterChanger Lib "oasis4i" (ByVal nChanger As Integer) As Integer
	Declare Function OI_GetFilterChanger Lib "oasis4i" (ByRef pnChanger As Integer) As Integer
	Declare Function OI_GetFilterChangerCount Lib "oasis4i" (ByRef pnChangers As Integer) As Integer
	Declare Function OI_GetFilterChangerInfo Lib "oasis4i" (ByVal nChanger As Integer, ByRef pnCard As Integer, ByRef pnAxisID As Integer) As Integer
	Declare Function OI_SetFilterChangerInfo Lib "oasis4i" (ByVal nChanger As Integer, ByVal nCard As Integer, ByVal nAxisID As Integer) As Integer
	Declare Function OI_IsFilterChangerDetected Lib "oasis4i" (ByVal nChanger As Integer, ByRef pbDetected As Short) As Integer
	Declare Function OI_SetFilterChangerConfig Lib "oasis4i" (ByVal nChanger As Integer, ByVal nControl As Integer) As Integer
	Declare Function OI_GetFilterChangerConfig Lib "oasis4i" (ByVal nChanger As Integer, ByRef pnControl As Integer) As Integer
	
	Declare Function OI_SetFilterChangerCruise Lib "oasis4i" (ByVal nChanger As Integer, ByVal nCruise As Integer) As Integer
	Declare Function OI_GetFilterChangerCruise Lib "oasis4i" (ByVal nChanger As Integer, ByRef pnCruise As Integer) As Integer
	Declare Function OI_SetFilterChangerRamp Lib "oasis4i" (ByVal nChanger As Integer, ByVal nRamp As Integer) As Integer
	Declare Function OI_GetFilterChangerRamp Lib "oasis4i" (ByVal nChanger As Integer, ByRef pnRamp As Integer) As Integer
	
	Declare Function OI_SetShutter Lib "oasis4i" (ByVal nPosition As Integer, ByVal nShutter As Integer) As Integer
	Declare Function OI_GetShutter Lib "oasis4i" (ByRef pnPosition As Integer, ByVal nShutter As Integer) As Integer
	Declare Function OI_SetShutterMulti Lib "oasis4i" (ByVal nStates As Integer, ByVal nStateMask As Integer) As Integer
	Declare Function OI_GetShutterMulti Lib "oasis4i" (ByRef pnStates As Integer) As Integer
	
	'///////////////////////////////////////////////////////////////////////
	'// Error
	Declare Function OI_GetLastError Lib "oasis4i" (ByRef pnCmd As Integer, ByRef pnRetCode As Integer, ByVal szDesc As String, ByVal nLen As Integer) As Integer
	Declare Function OI_EnableMsgReportDlg Lib "oasis4i" (ByVal bEnabled As Integer) As Integer
End Module